(define (count-nodes k)
  (let ((p (make-parser '( (s (a) (s s)) )
                        (lambda (l) (map (lambda (x) (list x x)) l)))))
    (let ((x (p (vector->list (make-vector k 'a)))))
      (count-them (parse->trees x 's 0 k)))))

(define (count-them nodes)
  (define marked (make-hashtable object-id assq))

  (define (marked? x)
    (or (not (pair? x))
        (hashtable-contains? marked x)))

  (define (mark node)
    (hashtable-put! marked node #t)
    (if (not (marked? (car node)))
        (mark (car node)))
    (if (not (marked? (cdr node)))
        (mark (cdr node))))

  (mark nodes)
  (hashtable-size marked))

'(define (count-them nodes)
  (define marked '())

  (define (marked? x)
    (or (not (pair? x))
        (memq x marked)))

  (define (mark node)
    (set! marked (cons node marked))
    (if (not (marked? (car node)))
        (mark (car node)))
    (if (not (marked? (cdr node)))
        (mark (cdr node))))

  (mark nodes)
  (length marked))
