; DOF processing code             -*- mode: scheme; mode: font-lock -*-
; 2000-11-19 / lth

(require 'list)
(require 'number)
(require 'generator)

;----------------------------------------------------------------------

(define (canned-dof-tables-and-plots)
  (display "DOF tables and plots")
  (newline)

  (load-dof-results)

  ; These create HTML tables
  (create-dof-summary-tables 'html)
  (create-dof-summary-tables 'html 'unreduced)
  (merge-dof-summary-html-tables)
  (merge-dof-unreduced-summary-html-tables)

  (create-dof-gc-tables 'html)
  (create-dof-gc-tables 'html 'unreduced)
  (merge-dof-gc-html-tables)
  (merge-dof-unreduced-gc-html-tables)

  ; These create LaTeX source
  (create-dof-summary-tables 'latex)
  (create-dof-gc-tables 'latex)

  ; These create data files for GNUplot
  ; Nothing yet!

  'canned-dof-tables-and-plots)


;----------------------------------------------------------------------

(define (crunch-dof-results)
  (for-each
   (lambda (fs)
     (let ((input (car fs))
           (output (cadr fs)))
       (display "*** Processing ")
       (display input)
       (newline)
       (let ((x (crunch input)))
         (call-with-output-file output
           (lambda (out)
             (write x out))))))
   '(("test/output/2000-04-07-1dof.upper+lower.1" 
      "crunched/1dof.upper+lower.1")
     ("test/output/2000-04-07-1dof.upper+lower.5" 
      "crunched/1dof.upper+lower.5")
     ("test/output/2000-04-07-1dof.upper.1" "crunched/1dof.upper.1")
     ("test/output/2000-04-07-1dof.upper.5" "crunched/1dof.upper.5")
     ("test/output/2000-04-07-1dof.var.1" "crunched/1dof.var.1")
     ("test/output/2000-04-07-1dof.var.5" "crunched/1dof.var.5")
     ("test/output/2000-04-07-2dof.upper+lower.1" 
      "crunched/2dof.upper+lower.1")
     ("test/output/2000-04-07-2dof.upper+lower.5" 
      "crunched/2dof.upper+lower.5")
     ("test/output/2000-04-07-2dof.upper.1" "crunched/2dof.upper.1")
     ("test/output/2000-04-07-2dof.upper.5" "crunched/2dof.upper.5")
     ("test/output/2000-04-07-2dof.var.1" "crunched/2dof.var.1")
     ("test/output/2000-04-07-2dof.var.5" "crunched/2dof.var.5")
     ("test/output/2000-04-07-3dof.upper+lower.1" 
      "crunched/3dof.upper+lower.1")
     ("test/output/2000-04-07-3dof.upper+lower.5" 
      "crunched/3dof.upper+lower.5")
     ("test/output/2000-04-07-3dof.upper.1" "crunched/3dof.upper.1")
     ("test/output/2000-04-07-3dof.upper.5" "crunched/3dof.upper.5")
     ("test/output/2000-04-07-3dof.var.1" "crunched/3dof.var.1")
     ("test/output/2000-04-07-3dof.var.5" "crunched/3dof.var.5")
     ("test/output/2000-04-07-4dof.upper+lower.1" 
      "crunched/4dof.upper+lower.1")
     ("test/output/2000-04-07-4dof.upper+lower.5" 
      "crunched/4dof.upper+lower.5")
     ("test/output/2000-04-07-4dof.upper.1" "crunched/4dof.upper.1")
     ("test/output/2000-04-07-4dof.upper.5" "crunched/4dof.upper.5")
     ("test/output/2000-04-07-4dof.var.1" "crunched/4dof.var.1")
     ("test/output/2000-04-07-4dof.var.5" "crunched/4dof.var.5"))))

(define (crunch-dof-float-results)
  (for-each
   (lambda (fs)
     (let ((input (car fs))
           (output (cadr fs)))
       (display "*** Processing ")
       (display input)
       (newline)
       (let ((x (crunch input)))
         (call-with-output-file output
           (lambda (out)
             (write x out))))))
   '(("test/output/2000-06-05-float-1dof.upper+lower.1"
      "crunched/float-1dof.upper+lower.1")
     ("test/output/2000-06-05-float-1dof.upper+lower.5"
      "crunched/float-1dof.upper+lower.5")
     ("test/output/2000-06-05-float-2dof.upper+lower.1"
      "crunched/float-2dof.upper+lower.1")
     ("test/output/2000-06-05-float-2dof.upper+lower.5"
      "crunched/float-2dof.upper+lower.5")
     ("test/output/2000-06-05-float-3dof.upper+lower.1"
      "crunched/float-3dof.upper+lower.1")
     ("test/output/2000-06-05-float-3dof.upper+lower.5"
      "crunched/float-3dof.upper+lower.5")
     ("test/output/2000-06-05-float-4dof.upper+lower.1"
      "crunched/float-4dof.upper+lower.1")
     ("test/output/2000-06-05-float-4dof.upper+lower.5"
      "crunched/float-4dof.upper+lower.5"))))

(define (crunch-dof-pboyer-results)
  (for-each
   (lambda (fs)
     (let ((input (car fs))
           (output (cadr fs)))
       (display "*** Processing ")
       (display input)
       (newline)
       (let ((x (crunch input)))
         (call-with-output-file output
           (lambda (out)
             (write x out))))))
   '(("test/output/2000-05-01-pboyer-1dof.var.1" "crunched/pboyer-1dof.var.1")
     ("test/output/2000-05-01-pboyer-1dof.var.5" "crunched/pboyer-1dof.var.5")
     ("test/output/2000-05-01-pboyer-2dof.var.1" "crunched/pboyer-2dof.var.1")
     ("test/output/2000-05-01-pboyer-2dof.var.5" "crunched/pboyer-2dof.var.5")
     ("test/output/2000-05-01-pboyer-3dof.var.1" "crunched/pboyer-3dof.var.1")
     ("test/output/2000-05-01-pboyer-3dof.var.5" "crunched/pboyer-3dof.var.5")
     ("test/output/2000-05-01-pboyer-4dof.var.1" "crunched/pboyer-4dof.var.1")
     ("test/output/2000-05-01-pboyer-4dof.var.5" "crunched/pboyer-4dof.var.5")
     )))

(define (crunch-dof-promotion-results)
  (for-each
   (lambda (fs)
     (let ((input (car fs))
           (output (cadr fs)))
       (display "*** Processing ")
       (display input)
       (newline)
       (let ((x (crunch input)))
         (call-with-output-file output
           (lambda (out)
             (write x out))))))
   '(("test/output/2000-06-22-promvol-4dof.var.1" 
      "crunched/promvol-4dof.var.1")
     ("test/output/2000-06-22-promvol-4dof.var.5" 
      "crunched/promvol-4dof.var.5"))))

(define (archive-dof-results)
  (let ((files 
         '(("output/2000-04-07-1dof.upper+lower.1")
           ("output/2000-04-07-1dof.upper+lower.5")
           ("output/2000-04-07-1dof.upper.1")
           ("output/2000-04-07-1dof.upper.5")
           ("output/2000-04-07-1dof.var.1")
           ("output/2000-04-07-1dof.var.5")
           ("output/2000-04-07-2dof.upper+lower.1")
           ("output/2000-04-07-2dof.upper+lower.5")
           ("output/2000-04-07-2dof.upper.1")
           ("output/2000-04-07-2dof.upper.5")
           ("output/2000-04-07-2dof.var.1")
           ("output/2000-04-07-2dof.var.5")
           ("output/2000-04-07-3dof.upper+lower.1")
           ("output/2000-04-07-3dof.upper+lower.5")
           ("output/2000-04-07-3dof.upper.1")
           ("output/2000-04-07-3dof.upper.5")
           ("output/2000-04-07-3dof.var.1")
           ("output/2000-04-07-3dof.var.5")
           ("output/2000-04-07-4dof.upper+lower.1")
           ("output/2000-04-07-4dof.upper+lower.5")
           ("output/2000-04-07-4dof.upper.1")
           ("output/2000-04-07-4dof.upper.5")
           ("output/2000-04-07-4dof.var.1")
           ("output/2000-04-07-4dof.var.5"))))
    (system (string-append (apply string-append 
                                  "tar cf - "
                                  (list-insert " " files))
                           " | gzip > archived/dof-results.tar.gz"))))

(define (crunch-dof-extra-results)
  (for-each
   (lambda (fs)
     (let ((input (car fs))
           (output (cadr fs)))
       (display "*** Processing ")
       (display input)
       (newline)
       (let ((x (crunch input)))
         (call-with-output-file output
           (lambda (out)
             (write x out))))))
   '(; Standard data for EARLEY
     ("test/output/2000-08-21-earley-1dof.upper+lower.5" 
      "crunched/1dof-extra.upper+lower.5") 
     ("test/output/2000-08-21-earley-1dof.upper.5" 
      "crunched/1dof-extra.upper.5") 
     ("test/output/2000-08-21-earley-2dof.upper+lower.5" 
      "crunched/2dof-extra.upper+lower.5") 
     ("test/output/2000-08-21-earley-2dof.upper.5" 
      "crunched/2dof-extra.upper.5") 
     ("test/output/2000-08-21-earley-3dof.upper+lower.5" 
      "crunched/3dof-extra.upper+lower.5") 
     ("test/output/2000-08-21-earley-3dof.upper.5" 
      "crunched/3dof-extra.upper.5") 
     ("test/output/2000-08-21-earley-4dof.upper+lower.5" 
      "crunched/4dof-extra.upper+lower.5") 
     ("test/output/2000-08-21-earley-4dof.upper.5" 
      "crunched/4dof-extra.upper.5") 

     ; Standard data for PERM and GCOLD (note: GCOLD with "buggy" RNG)
     ("test/output/2000-08-26-1dof.upper.1"
      "crunched/1dof-extra2.upper.1")
     ("test/output/2000-08-26-1dof.upper+lower.1"
      "crunched/1dof-extra2.upper+lower.1")
     ("test/output/2000-08-26-1dof.var.1"
      "crunched/1dof-extra2.var.1")
     ("test/output/2000-08-26-2dof.upper.1"
      "crunched/2dof-extra2.upper.1")
     ("test/output/2000-08-26-2dof.upper+lower.1"
      "crunched/2dof-extra2.upper+lower.1")
     ("test/output/2000-08-26-2dof.var.1"
      "crunched/2dof-extra2.var.1")
     ("test/output/2000-08-26-3dof.upper.1"
      "crunched/3dof-extra2.upper.1")
     ("test/output/2000-08-26-3dof.upper+lower.1"
      "crunched/3dof-extra2.upper+lower.1")
     ("test/output/2000-08-26-3dof.var.1"
      "crunched/3dof-extra2.var.1")
     ("test/output/2000-08-26-4dof.upper.1"
      "crunched/4dof-extra2.upper.1")
     ("test/output/2000-08-26-4dof.upper+lower.1"
      "crunched/4dof-extra2.upper+lower.1")
     ("test/output/2000-08-26-4dof.var.1"
      "crunched/4dof-extra2.var.1")

     ; Float reduction data for EARLEY
     ("test/output/2000-08-23-float-1dof.upper+lower.5" 
      "crunched/float-1dof-extra.upper+lower.5") 
     ("test/output/2000-08-23-float-2dof.upper+lower.5" 
      "crunched/float-2dof-extra.upper+lower.5") 
     ("test/output/2000-08-23-float-3dof.upper+lower.5" 
      "crunched/float-3dof-extra.upper+lower.5") 
     ("test/output/2000-08-23-float-4dof.upper+lower.5" 
      "crunched/float-4dof-extra.upper+lower.5") 

     ; Float data for PERM and GCOLD
     ("test/output/2000-08-30-float-1dof.upper+lower.1"
      "crunched/float-1dof-extra.upper+lower.1")
     ("test/output/2000-08-30-float-2dof.upper+lower.1"
      "crunched/float-2dof-extra.upper+lower.1")
     ("test/output/2000-08-30-float-3dof.upper+lower.1"
      "crunched/float-3dof-extra.upper+lower.1")
     ("test/output/2000-08-30-float-4dof.upper+lower.1"
      "crunched/float-4dof-extra.upper+lower.1")
     ("test/output/2000-09-02-float-4dof.upper+lower.1"
      "crunched/float-4dof-extra2.upper+lower.1")

     ; Promotion volume for PERM and GCOLD
     ("test/output/2000-09-04-promvol-4dof.var.1"
      "crunched/promvol-4dof-extra.var.1")

     ; Remembered set size data for 4DOF and 4DOF-NC.
     ("test/output/2000-08-25-rsize-4dof.upper+lower.1" 
      "crunched/rsize-4dof-extra.upper+lower.1") 
     ("test/output/2000-08-25-rsize-4dof.upper+lower.5" 
      "crunched/rsize-4dof-extra.upper+lower.5") 
     ("test/output/2000-08-25-rsize-4dof.upper.1" 
      "crunched/rsize-4dof-extra.upper.1") 
     ("test/output/2000-08-25-rsize-4dof.upper.5" 
      "crunched/rsize-4dof-extra.upper.5") 
     ("test/output/2000-08-25-rsize-4dof.var.1" 
      "crunched/rsize-4dof-extra.var.1") 
     ("test/output/2000-08-25-rsize-4dof.var.5" 
      "crunched/rsize-4dof-extra.var.5") 

     ; Remembered set trace data for gcbench
     ; FIX after trace code has been fixed.
     ("test/output/2000-09-04-rtrace-4dof.var.1" 
      "crunched/rtrace-4dof-extra.var.1")
     )))

(define (crunch-dof-lastminute-results)
  (for-each
   (lambda (fs)
     (let ((input (car fs))
           (output (cadr fs)))
       (display "*** Processing ")
       (display input)
       (newline)
       (let ((x (crunch input)))
         (call-with-output-file output
           (lambda (out)
             (write x out))))))
   '(("test/output/2000-10-01-rtrace-4dof.var.1"
      "crunched/rtrace-4dof-lastminute.var.1"))))


;----------------------------------------------------------------------

(define dof-results-loaded #f)

(define (load-dof-results)
  (if (not dof-results-loaded)
      (begin
        (set! dof-results-loaded #t)
        (for-each (lambda (x)
                    (let ((file (car x))
                          (variable (cadr x)))
                      (environment-set! (interaction-environment)
                                        variable
                                        (load-crunched-data file))))
                  '(("crunched/1dof.upper+lower.1" 1dof-upper+lower-1)
                    ("crunched/1dof.upper+lower.5" 1dof-upper+lower-5)
                    ("crunched/1dof.upper.1" 1dof-upper-1)
                    ("crunched/1dof.upper.5" 1dof-upper-5)
                    ("crunched/1dof.var.1" 1dof-var-1)
                    ("crunched/1dof.var.5" 1dof-var-5)
                    ("crunched/2dof.upper+lower.1" 2dof-upper+lower-1)
                    ("crunched/2dof.upper+lower.5" 2dof-upper+lower-5)
                    ("crunched/2dof.upper.1" 2dof-upper-1)
                    ("crunched/2dof.upper.5" 2dof-upper-5)
                    ("crunched/2dof.var.1" 2dof-var-1)
                    ("crunched/2dof.var.5" 2dof-var-5)
                    ("crunched/3dof.upper+lower.1" 3dof-upper+lower-1)
                    ("crunched/3dof.upper+lower.5" 3dof-upper+lower-5)
                    ("crunched/3dof.upper.1" 3dof-upper-1)
                    ("crunched/3dof.upper.5" 3dof-upper-5)
                    ("crunched/3dof.var.1" 3dof-var-1)
                    ("crunched/3dof.var.5" 3dof-var-5)
                    ("crunched/4dof.upper+lower.1" 4dof-upper+lower-1)
                    ("crunched/4dof.upper+lower.5" 4dof-upper+lower-5)
                    ("crunched/4dof.upper.1" 4dof-upper-1)
                    ("crunched/4dof.upper.5" 4dof-upper-5)
                    ("crunched/4dof.var.1" 4dof-var-1)
                    ("crunched/4dof.var.5" 4dof-var-5)))

        ; Now merge in other results
        ; EARLEY
        (set! 1dof-upper+lower-5
              (append (remove-benchmark '(5 earley:12) 1dof-upper+lower-5)
                      (load-crunched-data 
                       "crunched/1dof-extra.upper+lower.5")))
        (set! 1dof-upper-5
              (append (remove-benchmark '(5 earley:12) 1dof-upper-5)
                      (load-crunched-data "crunched/1dof-extra.upper.5")))
        (set! 2dof-upper+lower-5
              (append (remove-benchmark '(5 earley:12) 2dof-upper+lower-5)
                      (load-crunched-data 
                       "crunched/2dof-extra.upper+lower.5")))
        (set! 2dof-upper-5
              (append (remove-benchmark '(5 earley:12) 2dof-upper-5)
                      (load-crunched-data "crunched/2dof-extra.upper.5")))
        (set! 3dof-upper+lower-5
              (append (remove-benchmark '(5 earley:12) 3dof-upper+lower-5)
                      (load-crunched-data 
                       "crunched/3dof-extra.upper+lower.5")))
        (set! 3dof-upper-5
              (append (remove-benchmark '(5 earley:12) 3dof-upper-5)
                      (load-crunched-data "crunched/3dof-extra.upper.5")))
        (set! 4dof-upper+lower-5
              (append (remove-benchmark '(5 earley:12) 4dof-upper+lower-5)
                      (load-crunched-data 
                       "crunched/4dof-extra.upper+lower.5")))
        (set! 4dof-upper-5
              (append (remove-benchmark '(5 earley:12) 4dof-upper-5)
                      (load-crunched-data "crunched/4dof-extra.upper.5")))

        ; PERM and GCOLD
        (set! 1dof-upper-1
              (append 1dof-upper-1
                      (load-crunched-data "crunched/1dof-extra2.upper.1")))
        (set! 1dof-upper+lower-1
              (append 1dof-upper+lower-1
                      (load-crunched-data 
                       "crunched/1dof-extra2.upper+lower.1")))
        (set! 1dof-var-1
              (append 1dof-var-1
                      (load-crunched-data "crunched/1dof-extra2.var.1")))
        (set! 2dof-upper-1
              (append 2dof-upper-1
                      (load-crunched-data "crunched/2dof-extra2.upper.1")))
        (set! 2dof-upper+lower-1
              (append 2dof-upper+lower-1
                      (load-crunched-data 
                       "crunched/2dof-extra2.upper+lower.1")))
        (set! 2dof-var-1
              (append 2dof-var-1
                      (load-crunched-data "crunched/2dof-extra2.var.1")))
        (set! 3dof-upper-1
              (append 3dof-upper-1
                      (load-crunched-data "crunched/3dof-extra2.upper.1")))
        (set! 3dof-upper+lower-1
              (append 3dof-upper+lower-1
                      (load-crunched-data 
                       "crunched/3dof-extra2.upper+lower.1")))
        (set! 3dof-var-1
              (append 3dof-var-1
                      (load-crunched-data "crunched/3dof-extra2.var.1")))
        (set! 4dof-upper-1
              (append 4dof-upper-1
                      (load-crunched-data "crunched/4dof-extra2.upper.1")))
        (set! 4dof-upper+lower-1
              (append 4dof-upper+lower-1
                      (load-crunched-data 
                       "crunched/4dof-extra2.upper+lower.1")))
        (set! 4dof-var-1
              (append 4dof-var-1
                      (load-crunched-data "crunched/4dof-extra2.var.1")))

        #t)))

(define dof-float-results-loaded #f)

(define (load-dof-float-results)
  (if (not dof-float-results-loaded)
      (begin
        (for-each 
         (lambda (x)
           (let ((file (car x))
                 (variable (cadr x)))
             (environment-set! (interaction-environment)
                               variable
                               (load-crunched-data file))))
         '(("crunched/float-1dof.upper+lower.1" float-1dof-upper+lower-1)
           ("crunched/float-1dof.upper+lower.5" float-1dof-upper+lower-5)
           ("crunched/float-2dof.upper+lower.1" float-2dof-upper+lower-1)
           ("crunched/float-2dof.upper+lower.5" float-2dof-upper+lower-5)
           ("crunched/float-3dof.upper+lower.1" float-3dof-upper+lower-1)
           ("crunched/float-3dof.upper+lower.5" float-3dof-upper+lower-5)
           ("crunched/float-4dof.upper+lower.1" float-4dof-upper+lower-1)
           ("crunched/float-4dof.upper+lower.5" float-4dof-upper+lower-5)))

        ; Now merge in new results
        (set! float-1dof-upper+lower-5
              (append (remove-benchmark '(5 earley:12) 
                                        float-1dof-upper+lower-5)
                      (load-crunched-data 
                       "crunched/float-1dof-extra.upper+lower.5")))
        (set! float-2dof-upper+lower-5
              (append (remove-benchmark '(5 earley:12) 
                                        float-2dof-upper+lower-5)
                      (load-crunched-data 
                       "crunched/float-2dof-extra.upper+lower.5")))
        (set! float-3dof-upper+lower-5
              (append (remove-benchmark '(5 earley:12) 
                                        float-3dof-upper+lower-5)
                      (load-crunched-data 
                       "crunched/float-3dof-extra.upper+lower.5")))
        (set! float-4dof-upper+lower-5
              (append (remove-benchmark '(5 earley:12) 
                                        float-4dof-upper+lower-5)
                      (load-crunched-data 
                       "crunched/float-4dof-extra.upper+lower.5")))

        (set! float-1dof-upper+lower-1
              (append float-1dof-upper+lower-1
                      (remove-system '-dof-no-shadow-remsets
                                     (load-crunched-data 
                                      "crunched/float-1dof-extra.upper+lower.1"))))
        (set! float-2dof-upper+lower-1
              (append float-2dof-upper+lower-1
                      (remove-system '-dof-no-shadow-remsets
                                     (load-crunched-data 
                                      "crunched/float-2dof-extra.upper+lower.1"))))
        (set! float-3dof-upper+lower-1
              (append float-3dof-upper+lower-1
                      (remove-system '-dof-no-shadow-remsets
                                     (load-crunched-data 
                                      "crunched/float-3dof-extra.upper+lower.1"))))
        ; FIXME: this is wrong, because the number of entries in 
        ; the benchmark set can't vary.  Must wash the first data set
        ; by removing all promotion float data, and then insert the second
        ; data set (which has only promotion float data).
        (set! float-4dof-upper+lower-1
              (append float-4dof-upper+lower-1
                      (remove-system '-dof-fullgc-on-promotion
                                     (remove-system '-dof-no-shadow-remsets
                                                    (load-crunched-data 
                                                     "crunched/float-4dof-extra.upper+lower.1")))))
        (set! float-4dof-upper+lower-1
              (append float-4dof-upper+lower-1
                      (remove-system '-dof-no-shadow-remsets
                                     (load-crunched-data 
                                      "crunched/float-4dof-extra2.upper+lower.1"))))

        (set! dof-float-results-loaded #t)
        (unspecified))))

(define dof-pboyer-results-loaded #f)

(define (load-dof-pboyer-results)
  (if (not dof-pboyer-results-loaded)
      (begin
        (set! dof-pboyer-results-loaded #t)
        (for-each 
         (lambda (x)
           (let ((file (car x))
                 (variable (cadr x)))
             (environment-set! (interaction-environment)
                               variable
                               (load-crunched-data file))))
         '(("crunched/pboyer-1dof.var.1" pboyer-1dof-var-1)
           ("crunched/pboyer-1dof.var.5" pboyer-1dof-var-5)
           ("crunched/pboyer-2dof.var.1" pboyer-2dof-var-1)
           ("crunched/pboyer-2dof.var.5" pboyer-2dof-var-5)
           ("crunched/pboyer-3dof.var.1" pboyer-3dof-var-1)
           ("crunched/pboyer-3dof.var.5" pboyer-3dof-var-5)
           ("crunched/pboyer-4dof.var.1" pboyer-4dof-var-1)
           ("crunched/pboyer-4dof.var.5" pboyer-4dof-var-5)
           )))))

(define dof-promvol-results-loaded #f)

(define (load-dof-promvol-results)
  (if (not dof-promvol-results-loaded)
      (begin
        (for-each 
         (lambda (x)
           (let ((file (car x))
                 (variable (cadr x)))
             (environment-set! (interaction-environment)
                               variable
                               (load-crunched-data file))))
         '(("crunched/promvol-4dof.var.1" promvol-4dof-var-1)
           ("crunched/promvol-4dof.var.5" promvol-4dof-var-5)))

        (set! promvol-4dof-var-1
              (append promvol-4dof-var-1
                      (load-crunched-data "crunched/promvol-4dof-extra.var.1")))
        (set! dof-promvol-results-loaded #t)
        (unspecified))))


; Subset of the results: GCBENCH, GCOLD, PERM.
;
; Other results obtained and processed by other means; see the
; procedure dof-remset-traces1 in this file.

(define dof-rtrace-loaded #f)

(define (load-dof-rtrace-results)
  (if (not dof-rtrace-loaded)
      (begin
        (set! rtrace-4dof-var-1 
              (load-crunched-data "crunched/rtrace-4dof-extra.var.1"))
        (set! rtrace-4dof-var-5 '())

        (set! dof-rtrace-loaded #t)
        (unspecified))))

(define dof-rsize-extra-loaded #f)

(define (load-dof-rsize-extra-results)
  (if (not dof-rsize-extra-loaded)
      (begin
        (set! rsize-4dof-extra-upper-1 
              (load-crunched-data "crunched/rsize-4dof-extra.upper.1"))
        (set! rsize-4dof-extra-upper-5
              (load-crunched-data "crunched/rsize-4dof-extra.upper.5"))
        (set! rsize-4dof-extra-upper+lower-1  
              (load-crunched-data "crunched/rsize-4dof-extra.upper+lower.1"))
        (set! rsize-4dof-extra-upper+lower-5
              (load-crunched-data "crunched/rsize-4dof-extra.upper+lower.5"))
        (set! rsize-4dof-extra-var-1
              (load-crunched-data "crunched/rsize-4dof-extra.var.1"))
        (set! rsize-4dof-extra-var-5
              (load-crunched-data
               "crunched/rsize-4dof-extra.var.5"))
        (set! dof-rsize-extra-loaded #t)
        (unspecified))))

(define dof-rtrace-lastminute-loaded #f)

(define (load-dof-rtrace-lastminute-results)
  (if (not dof-rtrace-lastminute-loaded)
      (begin
        (set! rtrace-4dof-lastminute-var-1
              (load-crunched-data "crunched/rtrace-4dof-lastminute.var.1"))
        (set! dof-rtrace-lastminute-loaded #t)
        (unspecified))))

; ORDER MATTERS IN THE LISTS CREATED BY THE *-canonical-data FUNCTIONS.
;
; Remove load < 2.25 because other collectors were run only at L>=2.25.
; DOF data must also be filtered to extract best ff/s of four runs!

(define (remove-var-load-<-2.25 data)
  (filter (lambda (x) 
            (>= (caddr (system.info x)) 2.25))
          data))

; Problem: runs out the _output_ of basic-statistics.

(define (dof-compute-canonical-data raw-data)
  (dof-compute-runs raw-data dof-data-reduction-canonical-run))

(define (dof-compute-canonical-data-for-ff ff-setting raw-data)
  (dof-compute-runs raw-data 
                    (lambda (x)
                      (dof-data-reduction-canonical-for-ff ff-setting x))))

(define (dof-compute-canonical-data-for-s/ns s/ns-setting raw-data)
  (dof-compute-runs raw-data 
                    (lambda (x)
                      (dof-data-reduction-canonical-for-s/ns s/ns-setting x))))

(define (dof-compute-data-for-ff-s/ns ff s/ns raw-data)
  (dof-compute-runs raw-data
                    (lambda (x)
                      (dof-data-reduction-for-ff-s/ns ff s/ns x))))

(define (dof-compute-runs raw-data selector)
  (selector
   (flatten-option-noise
    (fluid-let ((no-warnings #t))
      (basic-statistics raw-data)))))

(define (do-1dof-canonical-data selector)
  (load-dof-results)
  `((,(selector 1dof-upper-1) 1) 
    (,(selector 1dof-upper-5) 5)
    (,(selector 1dof-upper+lower-1) 1) 
    (,(selector 1dof-upper+lower-5) 5)
    (,(selector (remove-var-load-<-2.25 1dof-var-1)) 1) 
    (,(selector (remove-var-load-<-2.25 1dof-var-5)) 5)))

(define (do-2dof-canonical-data selector)
  (load-dof-results)
  `((,(selector 2dof-upper-1) 1) 
    (,(selector 2dof-upper-5) 5)
    (,(selector 2dof-upper+lower-1) 1) 
    (,(selector 2dof-upper+lower-5) 5)
    (,(selector (remove-var-load-<-2.25 2dof-var-1)) 1) 
    (,(selector (remove-var-load-<-2.25 2dof-var-5)) 5)))

(define (do-3dof-canonical-data selector)
  (load-dof-results)
  `((,(selector 3dof-upper-1) 1) 
    (,(selector 3dof-upper-5) 5)
    (,(selector 3dof-upper+lower-1) 1)
    (,(selector 3dof-upper+lower-5) 5)
    (,(selector (remove-var-load-<-2.25 3dof-var-1)) 1) 
    (,(selector (remove-var-load-<-2.25 3dof-var-5)) 5)))

(define (do-4dof-canonical-data selector)
  (load-dof-results)
  `((,(selector 4dof-upper-1) 1)
    (,(selector 4dof-upper-5) 5)
    (,(selector 4dof-upper+lower-1) 1)
    (,(selector 4dof-upper+lower-5) 5)
    (,(selector (remove-var-load-<-2.25 4dof-var-1)) 1) 
    (,(selector (remove-var-load-<-2.25 4dof-var-5)) 5)))

; The original runs did not distinguish between remembered-set data and
; run-time system data.  This works well most of the time because the
; amount of non-remembered set run-time system data is known: it is one
; megabyte, the size of the descriptor table.  Therefore the remembered
; set data could be computed from the run-time system data.  ;
;
; However, for the canoncial runs of 4DOF (and any runs of the DOF
; collector with the full GC enabled) the amount of RTS "other" data is
; not known because the mark/sweep collector allocates mark bitmaps and
; the mark stack from that data area as well.  Therefore, some catchup
; runs of 4DOF were made to provide better data for the remembered set
; sizes for 4DOF.
;
; To make things complicated, there are no less than four batches of
; runs to merge:
;  - the original runs, from which we will take data for 1DOF, 2DOF,
;    3DOF, and 4DOF-NC except for the EARLEY benchmark
;  - the catchup runs of EARLEY, from which we will take all data for
;    this benchmark
;  - the catchup remembered-set-size runs, from which we will take
;    data for 4DOF for GCBENCH, NBOYER, SBOYER, and TWOBIT
;  - the catchup runs for GCOLD and PERM, from which we will take all
;    data for those benchmarks.
;
; Finally, the processing code must be careful not to use any datum for
; 1DOF, 2DOF, and 3DOF for GCBENCH, NBOYER, SBOYER, or TWOBIT if the
; full GC was run during the run in question.
;
; Thus, the processing code can use the standard canonical results if it
; is careful not to choose results that might have been compromised by
; full GC, and only 4DOF needs a new data set.  We construct that here.

(define (do-4dof-remset-size-canonical-data selector)
  (define (fixit a b)
    (append (remove-benchmarks '((1 gcbench:5)
                                 (1 nboyer:3)
                                 (5 nboyer:3)
                                 (5 sboyer:4)
                                 (1 twobitlong)
                                 (1 twobitshort)
                                 (5 twobitshort))
                               a)
            b))

  (load-dof-results)
  (load-dof-rsize-extra-results)
  `((,(selector (fixit 4dof-upper-1 rsize-4dof-extra-upper-1)) 1)
    (,(selector (fixit 4dof-upper-5 rsize-4dof-extra-upper-5)) 5)
    (,(selector (fixit 4dof-upper+lower-1 rsize-4dof-extra-upper+lower-1)) 1)
    (,(selector (fixit 4dof-upper+lower-5 rsize-4dof-extra-upper+lower-5)) 5)
    (,(selector (fixit (remove-var-load-<-2.25 4dof-var-1) 
                       rsize-4dof-extra-var-1))
     1) 
    (,(selector (fixit (remove-var-load-<-2.25 4dof-var-5) 
                       rsize-4dof-extra-var-5))
     5)))

; Canonical canonical.

(define (1dof-canonical-data . rest)
  (do-1dof-canonical-data 
   (if (null? rest)
       dof-compute-canonical-data
       (lambda (x)
         (select-benchmarks (dof-compute-canonical-data x) (car rest))))))

(define (2dof-canonical-data . rest)
  (do-2dof-canonical-data
   (if (null? rest)
       dof-compute-canonical-data
       (lambda (x)
         (select-benchmarks (dof-compute-canonical-data x) (car rest))))))

(define (3dof-canonical-data . rest)
  (do-3dof-canonical-data
   (if (null? rest)
       dof-compute-canonical-data
       (lambda (x)
         (select-benchmarks (dof-compute-canonical-data x) (car rest))))))

(define (4dof-canonical-data . rest)
  (do-4dof-canonical-data
   (if (null? rest)
       dof-compute-canonical-data
       (lambda (x)
         (select-benchmarks (dof-compute-canonical-data x) (car rest))))))

(define (4dof-remset-size-canonical-data . rest)
  (do-4dof-remset-size-canonical-data
   (if (null? rest)
       dof-compute-canonical-data
       (lambda (x)
         (select-benchmarks (dof-compute-canonical-data x) (car rest))))))

(define (4dof-noncanonical-data . rest)
  (do-4dof-canonical-data
   (if (null? rest)
       (lambda (x)
         (dof-compute-canonical-data-for-ff 0 x))
       (lambda (x)
         (select-benchmarks (dof-compute-canonical-data-for-ff 0 x)
                            (car rest))))))

; Full frequency

(define (1dof-canonical-data-for-ff ff)
  (do-1dof-canonical-data (lambda (data)
                            (dof-compute-canonical-data-for-ff ff data))))

(define (2dof-canonical-data-for-ff ff)
  (do-2dof-canonical-data (lambda (data)
                            (dof-compute-canonical-data-for-ff ff data))))

(define (3dof-canonical-data-for-ff ff)
  (do-3dof-canonical-data (lambda (data)
                            (dof-compute-canonical-data-for-ff ff data))))

(define (4dof-canonical-data-for-ff ff)
  (do-4dof-canonical-data (lambda (data)
                            (dof-compute-canonical-data-for-ff ff data))))

; Shadow/noshadow

(define (1dof-canonical-data-for-s/ns s/ns)
  (do-1dof-canonical-data (lambda (data)
                            (dof-compute-canonical-data-for-s/ns s/ns data))))

(define (2dof-canonical-data-for-s/ns s/ns)
  (do-2dof-canonical-data (lambda (data)
                            (dof-compute-canonical-data-for-s/ns s/ns data))))

(define (3dof-canonical-data-for-s/ns s/ns)
  (do-3dof-canonical-data (lambda (data)
                            (dof-compute-canonical-data-for-s/ns s/ns data))))

(define (4dof-canonical-data-for-s/ns s/ns)
  (do-4dof-canonical-data (lambda (data)
                            (dof-compute-canonical-data-for-s/ns s/ns data))))

(define (dof-compute-float-canonical-data raw-data)
  (fluid-let ((no-warnings #t))
    (flatten-option-noise 
     (basic-statistics raw-data))))

(define (1dof-float-data-normal)
  (load-dof-results)
  `((,(select-trigger 3.0 (dof-compute-canonical-data 1dof-upper+lower-1)) 1)
    (,(select-trigger 3.0 (dof-compute-canonical-data 1dof-upper+lower-5)) 5)))

(define (1dof-float-data-reduced opt)
  (load-dof-float-results)
  `((,(select-if-present opt
       (dof-compute-float-canonical-data float-1dof-upper+lower-1)) 1)
    (,(select-if-present opt
       (dof-compute-float-canonical-data float-1dof-upper+lower-5)) 5)))

(define (2dof-float-data-normal)
  (load-dof-results)
  `((,(select-trigger 3.0 (dof-compute-canonical-data 2dof-upper+lower-1)) 1)
    (,(select-trigger 3.0 (dof-compute-canonical-data 2dof-upper+lower-5)) 5)))

(define (2dof-float-data-reduced opt)
  (load-dof-float-results)
  `((,(select-if-present opt 
       (dof-compute-float-canonical-data float-2dof-upper+lower-1)) 1)
    (,(select-if-present opt
       (dof-compute-float-canonical-data float-2dof-upper+lower-5)) 5)))

(define (3dof-float-data-normal)
  (load-dof-results)
  `((,(select-trigger 3.0 (dof-compute-canonical-data 3dof-upper+lower-1)) 1)
    (,(select-trigger 3.0 (dof-compute-canonical-data 3dof-upper+lower-5)) 5)))

(define (3dof-float-data-reduced opt)
  (load-dof-float-results)
  `((,(select-if-present opt
       (dof-compute-float-canonical-data float-3dof-upper+lower-1)) 1)
    (,(select-if-present opt
       (dof-compute-float-canonical-data float-3dof-upper+lower-5)) 5)))

(define (4dof-float-data-normal)
  (load-dof-results)
  `((,(select-trigger 3.0 (dof-compute-canonical-data 4dof-upper+lower-1)) 1)
    (,(select-trigger 3.0 (dof-compute-canonical-data 4dof-upper+lower-5)) 5)))

(define (4dof-float-data-noncanonical)
  (load-dof-results)
  `((,(select-trigger 3.0 (dof-compute-data-for-ff-s/ns 0 #t 4dof-upper+lower-1)) 1)
    (,(select-trigger 3.0 (dof-compute-data-for-ff-s/ns 0 #t 4dof-upper+lower-5)) 5)))

(define (4dof-float-data-reduced opt)
  (load-dof-float-results)
  `((,(select-if-present opt
       (dof-compute-float-canonical-data float-4dof-upper+lower-1)) 1)
    (,(select-if-present opt
       (dof-compute-float-canonical-data float-4dof-upper+lower-5)) 5)))

(define (1dof-float-canonical-data)
  `((,(dof-compute-canonical-data 1dof-upper+lower-1) 1)
    (,(dof-compute-canonical-data 1dof-upper+lower-5) 5)
    (,(dof-compute-float-canonical-data float-1dof-upper+lower-1) 1)
    (,(dof-compute-float-canonical-data float-1dof-upper+lower-5) 5)))

(define (2dof-float-canonical-data)
  `((,(dof-compute-canonical-data 2dof-upper+lower-1) 1)
    (,(dof-compute-canonical-data 2dof-upper+lower-5) 5)
    (,(dof-compute-float-canonical-data float-2dof-upper+lower-1) 1)
    (,(dof-compute-float-canonical-data float-2dof-upper+lower-5) 5)))

(define (3dof-float-canonical-data)
  `((,(dof-compute-canonical-data 3dof-upper+lower-1) 1)
    (,(dof-compute-canonical-data 3dof-upper+lower-5) 5)
    (,(dof-compute-float-canonical-data float-3dof-upper+lower-1) 1)
    (,(dof-compute-float-canonical-data float-3dof-upper+lower-5) 5)))

(define (4dof-float-canonical-data)
  `((,(dof-compute-canonical-data 4dof-upper+lower-1) 1)
    (,(dof-compute-canonical-data 4dof-upper+lower-5) 5)
    (,(dof-compute-float-canonical-data float-4dof-upper+lower-1) 1)
    (,(dof-compute-float-canonical-data float-4dof-upper+lower-5) 5)))

(define (4dof-float-noncanonical-data)
  `((,(dof-compute-noncanonical-data 4dof-upper+lower-1) 1)
    (,(dof-compute-noncanonical-data 4dof-upper+lower-5) 5)
    (,(dof-compute-float-canonical-data float-4dof-upper+lower-1) 1)
    (,(dof-compute-float-canonical-data float-4dof-upper+lower-5) 5)))

(define (generic-dof-summary-tables prefix suffix variables stats1 stats5 type)
  (do ((variables variables (cdr variables)))
      ((null? variables))
    (let* ((var  (car variables))
           (s    (symbol->string var))
           (file (case type
                   ((latex) (string-append "tables/" prefix s suffix ".tex"))
                   ((html) (string-append "html-tables/" 
                                          prefix s suffix ".html"))
                   ((text) "/dev/tty")
                   (else ???)))
           (n    (- (char->integer 
                     (string-ref s (- (string-length s) 1)))
                    (char->integer #\0)))
           (data (environment-get (interaction-environment) 
                                  var))
           (limit (not (string=? "var" (substring s 5 8)))))
      (display var)
      (newline)
      (with-output-to-file file
        (lambda ()
          (cond ((= n 1)
                 (if limit
                     (stats1 data 'no-load/trigger)
                     (stats1 data 'no-heap-limit)))
                ((= n 5)
                 (if limit
                     (stats5 data 'no-load/trigger)
                     (stats5 data 'no-heap-limit)))
                (else ???)))))))

(define (create-dof-summary-tables . rest)

  (define (var-run? datum)
    (let ((x (assq 'system-info datum)))
      (and x (eq? 'variable (caddr x)))))

  (define filter 
    (lambda (x)
      (if (and (not (null? x))
               (var-run? (car x)))
          (select-load-factor 2.25
                              (dof-data-reduction-canonical-run
                               (flatten-option-noise x))
                              >=)
          (dof-data-reduction-canonical-run
           (flatten-option-noise x)))))

  (define suffix "")
  (define type 'latex)                  ; default
  (define break-unreduced #f)

  (define (stats list-of-systems . rest)
    (apply standard-report list-of-systems
           '((("CPU")         ms run-cpu-best)
             (("CPU GC")      ms run-cpu-gc-best)
             (("CPU" "Promote")  ms run-cpu-gc-promote-best)
             (("CPU" "Full")     ms run-cpu-gc-full-best)
             (("Major" "GCs") n  run-major-collections-best)
             (("Full" "GCs")  n  run-full-collections-best)
             (("Marking")        mb run-bytes-marked-best)
             (("Heap" "used") mb bytes-max-heap))
           'no-warnings 
           'break 9 ; workaround for bug, was: (if (eq? type 'latex) 8 10000)
           type
           'no-variance
           'no-fail
           'filter filter
           'sort sort-by-trigger
           'header-filter (lambda (bm collector heap aux)
                            (values (format-benchmark-name bm)
                                    (format #f "~aDOF" (cadr collector))
                                    heap
                                    (if (null? aux) 
                                        #f
                                        (format #f "T=~a" (car aux)))))
           (if break-unreduced
               (cons 'break-dof-unreduced rest)
               rest)))

  (if (memq 'unreduced rest)
      (begin
        (set! filter flatten-option-noise)
        (set! break-unreduced #t)
        (set! suffix "-u")))
  (if (memq 'html rest)
      (set! type 'html))

  (load-dof-results)
  (generic-dof-summary-tables 
   "" suffix 
   '(1dof-upper+lower-1 1dof-upper+lower-5
     1dof-upper-1 1dof-upper-5
     1dof-var-1 1dof-var-5
     2dof-upper+lower-1 2dof-upper+lower-5
     2dof-upper-1 2dof-upper-5
     2dof-var-1 2dof-var-5
     3dof-upper+lower-1 3dof-upper+lower-5
     3dof-upper-1 3dof-upper-5
     3dof-var-1 3dof-var-5
     4dof-upper+lower-1 4dof-upper+lower-5
     4dof-upper-1 4dof-upper-5
     4dof-var-1 4dof-var-5)
   stats stats
   type))

; Very useful for debugging.

(define (display-contents var . rest)

  (define break-unreduced (memq 'break rest))

  (define (stats list-of-systems . rest)
    (apply standard-report list-of-systems
           `((("Num" "GCs")   n  run-garbage-collections-best)
             (("Major" "GCs") n  run-major-collections-best)
             (("Full" "GCs")  n  run-full-collections-best)
             (("FF;" "S/NS")  bv ,(lambda (get present?)
                                    (list (= (get '-dof-fullgc-frequency) 1)
                                          (not (get '-dof-no-shadow-remsets)))))
             (("Full")        tf ,(lambda (get present?)
                                    (cond ((and (present? '-dof-fullgc-on-collection)
                                                (get '-dof-fullgc-on-collection))
                                           "GC")
                                          ((and (present? '-dof-fullgc-on-promotion)
                                                (get '-dof-fullgc-on-promotion))
                                           "Prom")
                                          (else ""))))
             (("Heap" "used") mb bytes-max-heap))
           'no-warnings 
           'break 10000
           'text
           'no-variance
           'filter flatten-option-noise
           (if break-unreduced
               (cons 'break-dof-unreduced rest)
               rest)))

  (generic-dof-summary-tables "" "" (list var) stats stats 'text))

(define (merge-dof-summary-html-tables)
  (merge-summary-html-tables
   "html-tables/1dof-general.html"
   "1DOF results | General"
    '("1dof-upper+lower-1" "1dof-upper+lower-5"
      "1dof-upper-1" "1dof-upper-5"
      "1dof-var-1" "1dof-var-5"))

  (merge-summary-html-tables
   "html-tables/2dof-general.html"
   "2DOF results | General"
    '("2dof-upper+lower-1" "2dof-upper+lower-5"
      "2dof-upper-1" "2dof-upper-5"
      "2dof-var-1" "2dof-var-5"))

  (merge-summary-html-tables
   "html-tables/3dof-general.html"
   "3DOF results | General"
    '("3dof-upper+lower-1" "3dof-upper+lower-5"
      "3dof-upper-1" "3dof-upper-5"
      "3dof-var-1" "3dof-var-5"))

  (merge-summary-html-tables
   "html-tables/4dof-general.html"
   "4DOF results | General"
    '("4dof-upper+lower-1" "4dof-upper+lower-5"
      "4dof-upper-1" "4dof-upper-5"
      "4dof-var-1" "4dof-var-5"))

  #t)

(define (merge-dof-unreduced-summary-html-tables)
  (merge-summary-html-tables
   "html-tables/1dof-general-unreduced.html"
   "1DOF unreduced results | General"
    '("1dof-upper+lower-1-u" "1dof-upper+lower-5-u"
      "1dof-upper-1-u" "1dof-upper-5-u"
      "1dof-var-1-u" "1dof-var-5-u"))

  (merge-summary-html-tables
   "html-tables/2dof-general-unreduced.html"
   "2DOF unreduced results | General"
    '("2dof-upper+lower-1-u" "2dof-upper+lower-5-u"
      "2dof-upper-1-u" "2dof-upper-5-u"
      "2dof-var-1-u" "2dof-var-5-u"))

  (merge-summary-html-tables
   "html-tables/3dof-general-unreduced.html"
   "3DOF unreduced results | General"
    '("3dof-upper+lower-1-u" "3dof-upper+lower-5-u"
      "3dof-upper-1-u" "3dof-upper-5-u"
      "3dof-var-1-u" "3dof-var-5-u"))

  (merge-summary-html-tables
   "html-tables/4dof-general-unreduced.html"
   "4DOF unreduced results | General"
    '("4dof-upper+lower-1-u" "4dof-upper+lower-5-u"
      "4dof-upper-1-u" "4dof-upper-5-u"
      "4dof-var-1-u" "4dof-var-5-u"))

  #t)

(define (create-dof-gc-tables . rest)

  (define filter 
    (lambda (x)
      (dof-data-reduction-canonical-run
       (flatten-option-noise x))))

  (define suffix "")
  (define type 'latex)
  (define break-unreduced #f)

  (define (stats1 list-of-systems . rest)
    (apply standard-report list-of-systems
           `((("CPU")         ms cpu-best)
             (("CPU GC")      ms cpu-gc-best)
             (("CPU" "User")  ms cpu-user-best)
             (("CPU" "Sys.")  ms cpu-system-best)
             (("CPU" "Mut.")  ms ,(lambda (get present?)
                                    (- (get 'cpu-best) 
                                       (get 'cpu-gc-best))))
             (("Copy" "gc")       mb bytes-copied-best)
             (("Move" "los")      mb bytes-moved-best)
             (("Mark" "full")     mb bytes-marked-full-best)
             (("Objs" "inserted") exact.kf.1 remset-entries-added-best)
             (("Objs" "scanned")  exact.kf.1 remset-entries-scanned-best)
             (("Bytes" "scanned") exact.kf.1 remset-bytes-scanned-best)
             (("Objs" "removed")  exact.kf.1 remset-entries-removed-best)
             (("Bytes/" "object") nf.1 
                                  ,(lambda (get present?)
                                     (exact->inexact
                                      (/ (get 'remset-bytes-scanned-best)
                                         (get 'remset-entries-scanned-best)))))
             (("Remset" "peak")   kb bytes-max-remset))
           'no-warnings 
           'break (if (eq? type 'latex) 10 10000)
           type
           'no-variance 
           'no-load/trigger
           'filter filter
           (if break-unreduced
               (cons 'break-dof-unreduced rest)
               rest)))

  (define (stats5 list-of-systems . rest)
    (apply standard-report list-of-systems
           `((("CPU")         ms run-cpu-best)
             (("CPU GC")      ms run-cpu-gc-best)
             (("CPU" "User")      ms run-cpu-user-best)
             (("CPU" "Sys.")      ms run-cpu-system-best)
             (("CPU" "Mut.")      ms ,(lambda (get present?)
                                        (- (get 'run-cpu-best) 
                                           (get 'run-cpu-gc-best))))
             (("Copy" "gc")       mb run-bytes-copied-best)
             (("Move" "los")      mb run-bytes-moved-best)
             (("Mark" "full")     mb run-bytes-marked-full-best)
             (("Objs" "inserted") kf.1 run-remset-entries-added-best)
             (("Objs" "scanned")  kf.1 run-remset-entries-scanned-best)
             (("Bytes" "scanned") kf.1 run-remset-bytes-scanned-best)
             (("Objs" "removed")  kf.1 run-remset-entries-removed-best)
             (("Bytes/" "object") nf.1 
                                  ,(lambda (get present?)
                                     (exact->inexact
                                      (/ (get 'run-remset-bytes-scanned-best)
                                         (get 'run-remset-entries-scanned-best)
                                         ))))
             (("Remset" "peak")   kb bytes-max-remset))
           'no-warnings
           'break (if (eq? type 'latex) 10 10000)
           type
           'no-variance
           'no-load/trigger
           'filter filter
           (if break-unreduced
               (cons 'break-dof-unreduced rest)
               rest)))

  (if (memq 'unreduced rest)
      (begin 
        (set! filter flatten-option-noise)
        (set! break-unreduced #t)
        (set! suffix "-u")))
  (if (memq 'html rest)
      (begin
        (set! type 'html)))
  (generic-dof-summary-tables 
   "gc-" suffix 
   '(1dof-upper+lower-1 1dof-upper+lower-5
     1dof-upper-1 1dof-upper-5
     1dof-var-1 1dof-var-5
     2dof-upper+lower-1 2dof-upper+lower-5
     2dof-upper-1 2dof-upper-5
     2dof-var-1 2dof-var-5
     3dof-upper+lower-1 3dof-upper+lower-5
     3dof-upper-1 3dof-upper-5
     3dof-var-1 3dof-var-5
     4dof-upper+lower-1 4dof-upper+lower-5
     4dof-upper-1 4dof-upper-5
     4dof-var-1 4dof-var-5)
   stats1 stats5 
   type))

(define (merge-dof-gc-html-tables)
  (merge-summary-html-tables
   "html-tables/1dof-gc.html"
   "1DOF results | GC"
    '("gc-1dof-upper+lower-1" "gc-1dof-upper+lower-5"
      "gc-1dof-upper-1" "gc-1dof-upper-5"
      "gc-1dof-var-1" "gc-1dof-var-5"))

  (merge-summary-html-tables
   "html-tables/2dof-gc.html"
   "2DOF results | GC"
    '("gc-2dof-upper+lower-1" "gc-2dof-upper+lower-5"
      "gc-2dof-upper-1" "gc-2dof-upper-5"
      "gc-2dof-var-1" "gc-2dof-var-5"))

  (merge-summary-html-tables
   "html-tables/3dof-gc.html"
   "3DOF results | GC"
    '("gc-3dof-upper+lower-1" "gc-3dof-upper+lower-5"
      "gc-3dof-upper-1" "gc-3dof-upper-5"
      "gc-3dof-var-1" "gc-3dof-var-5"))

  (merge-summary-html-tables
   "html-tables/4dof-gc.html"
   "4DOF results | GC"
    '("gc-4dof-upper+lower-1" "gc-4dof-upper+lower-5"
      "gc-4dof-upper-1" "gc-4dof-upper-5"
      "gc-4dof-var-1" "gc-4dof-var-5"))

  #t)

(define (merge-dof-unreduced-gc-html-tables)
  (merge-summary-html-tables
   "html-tables/1dof-gc-unreduced.html"
   "1DOF unreduced results | GC"
    '("gc-1dof-upper+lower-1-u" "gc-1dof-upper+lower-5-u"
      "gc-1dof-upper-1-u" "gc-1dof-upper-5-u"
      "gc-1dof-var-1-u" "gc-1dof-var-5-u"))

  (merge-summary-html-tables
   "html-tables/2dof-gc-unreduced.html"
   "2DOF unreduced results | GC"
    '("gc-2dof-upper+lower-1-u" "gc-2dof-upper+lower-5-u"
      "gc-2dof-upper-1-u" "gc-2dof-upper-5-u"
      "gc-2dof-var-1-u" "gc-2dof-var-5-u"))

  (merge-summary-html-tables
   "html-tables/3dof-gc-unreduced.html"
   "3DOF unreduced results | GC"
    '("gc-3dof-upper+lower-1-u" "gc-3dof-upper+lower-5-u"
      "gc-3dof-upper-1-u" "gc-3dof-upper-5-u"
      "gc-3dof-var-1-u" "gc-3dof-var-5-u"))

  (merge-summary-html-tables
   "html-tables/4dof-gc-unreduced.html"
   "4DOF unreduced results | GC"
    '("gc-4dof-upper+lower-1-u" "gc-4dof-upper+lower-5-u"
      "gc-4dof-upper-1-u" "gc-4dof-upper-5-u"
      "gc-4dof-var-1-u" "gc-4dof-var-5-u"))

  #t)


; GC time analyis
;
; Show where the time and copy work goes, across benchmarks and collectors.

(define (dof-gc-time-analysis . rest)

  (define results '())

  (define (lookup bm)
    (let ((probe (assoc bm results)))
      (if probe
          probe
          (let ((x (list bm 0 0 0 0 0)))
            (set! results (cons x results))
            x))))

  (define (promtime cell) (list-ref cell 1))
  (define (gctime cell) (list-ref cell 2))
  (define (promvol cell) (list-ref cell 3))
  (define (gcvol cell) (list-ref cell 4))
  (define (counter cell) (list-ref cell 5))
  (define (inc-promtime cell n)
    (list-set! cell 1 (+ (list-ref cell 1) n)))
  (define (inc-gctime cell n)
    (list-set! cell 2 (+ (list-ref cell 2) n)))
  (define (inc-promvol cell n)
    (list-set! cell 3 (+ (list-ref cell 3) n)))
  (define (inc-gcvol cell n)
    (list-set! cell 4 (+ (list-ref cell 4) n)))
  (define (inc-counter cell)
    (list-set! cell 5 (+ (list-ref cell 5) 1)))

  (define (process-datum datum n)
    (if (all-iterations-succeeded? datum)
        (let* ((bm (list n (cdr (assq 'benchmark-name datum))))
               (cell (lookup bm)))
          (inc-promtime cell
                        (cdr (assq 'run-cpu-gc-promote-best datum)))
          (inc-gctime cell
                      (cdr (assq 'run-cpu-gc-collect-best datum)))
          (inc-promvol cell
                       (cdr (assq 'run-bytes-copied-promotion-best datum)))
          (inc-gcvol cell
                     (cdr (assq 'run-bytes-copied-collection-best datum)))
          (inc-counter cell))))

  (define (analyze tag all-data)
    (set! results '())
    (for-each-benchmark-result process-datum all-data)
    (map (lambda (x) 
           (list (cons tag (car x)) 
                 (/ (promtime x) (counter x))
                 (/ (gctime x) (counter x))
                 (/ (promvol x) (counter x))
                 (/ (gcvol x) (counter x))))
         results))

  (define (gc-time-analysis)
    (let ((results 
           (append 
            (analyze 0 (2gen-canonical-data))
            (analyze 1 (1dof-canonical-data))
            (analyze 2 (2dof-canonical-data))
            (analyze 3 (3dof-canonical-data))
            (analyze 4 (4dof-canonical-data)))))
      (map (lambda (bm)
             (cons bm
                   (map 
                    (lambda (gc)
                      (let ((v (assoc (cons gc bm) results)))
                        (if v
                            (list gc 
                                  (format-ms-as-s (cadr v))  ; promotion time
                                  (format-ms-as-s (caddr v)) ; gc time
                                  (format-byte-volume.1      ; promotion volume
                                   (cadddr v))
                                  (format-byte-volume.1      ; gc volume
                                    (car (cddddr v))))
                            (list gc #f #f #f #f))))
                    (iota 5))))
           benchmark-names)))

  ; Yet another LaTeX table

  (define (display-analysis data out)

    (define (header out)
      (format out "\\begin{tabular}{|l|rr|rr|rr|rr|rr|}~%\\hline~%")
      (format out " & \\multicolumn{2}{c|}{2GEN} & \\multicolumn{2}{c|}{1DOF}")
      (format out " & \\multicolumn{2}{c|}{2DOF} & \\multicolumn{2}{c|}{3DOF}")
      (format out " & \\multicolumn{2}{c|}{4DOF} \\\\~%")
      (do ((i 0 (+ i 1)))
          ((= i 5))
        (format out " & promote & collect"))
      (format out " \\\\~%")
      (format out "\\hline~%"))

    (define (body out f1 f2)
      (for-each (lambda (datum)
                  (format out " ~a " (format-benchmark-name (car datum)))
                  (for-each (lambda (n i)
                              (if (not (= (car n) i))
                                  (error "Collectors not correctly sorted."))
                              (format out " & ~a & ~a " 
                                      (or (f1 n) "")
                                      (or (f2 n) "")))
                            (cdr datum)
                            (iota 5))
                  (format out "\\\\~%"))
                (sort data (lambda (a b) 
                             (benchmark<? (car a) (car b))))))

    (define (tail out)
      (format out "\\hline~%")
      (format out "\\end{tabular}~%"))

    (let ((s1 (open-output-string))
          (s2 (open-output-string)))
      (header s1)
      (header s2)
      (body s1 cadr caddr)
      (body s2 cadddr (lambda (x) (car (cddddr x))))
      (tail s1)
      (tail s2)
      (display (get-output-string s1))
      (newline)
      (display (get-output-string s2))))

  (load-dof-results)
  (load-gen-results)
  (if (null? rest)
      (display-analysis (gc-time-analysis) (current-output-port))
      (call-with-output-file (car rest) 
        (lambda (out)
          (display-analysis (gc-time-analysis) out)))))


; Mark/cons ratios -- basic stuff
;
; Table of average mark/cons ratios across benchmarks and collectors.
; This is not good enough for a real analysis but for the qualitative
; overview it's just fine.

(define (dof-mark/cons-analysis . rest)

  (define results '())

  (define (lookup bm)
    (let ((probe (assoc bm results)))
      (if probe
          probe
          (let ((x (list bm 0 0)))
            (set! results (cons x results))
            x))))

  (define (process-datum datum n)
    (if (all-iterations-succeeded? datum)
        (let* ((bm (list n (cdr (assq 'benchmark-name datum))))
               (cell (lookup bm)))
          (set-car! (cdr cell) 
                    (+ (cadr cell)
                       (/ (+ (cdr (assq 'run-bytes-copied-best datum))
                             (cdr (assq 'run-bytes-moved-best datum))
                             (cdr (assq 'run-bytes-marked-full-best datum)))
                          (canonical-allocation bm))))
          (set-car! (cddr cell) (+ (caddr cell) 1)))))

  (define (analyze tag all-data)
    (set! results '())
    (for-each-benchmark-result process-datum all-data)
    (map (lambda (x) 
           (cons (cons tag (car x)) (/ (cadr x) (caddr x))))
         results))

  (define dec (decimals 2))

  (define (mark/cons-analysis)
    (let ((results 
           (append 
            (analyze 0 (2gen-canonical-data))
            (analyze 1 (1dof-canonical-data))
            (analyze 2 (2dof-canonical-data))
            (analyze 3 (3dof-canonical-data))
            (analyze 4 (4dof-canonical-data)))))
      (map (lambda (bm)
             (cons bm
                   (map 
                    (lambda (gc)
                      (let ((v (assoc (cons gc bm) results)))
                        (if v
                            (list gc (dec (cdr v)))
                            (list gc #f))))
                    (iota 5))))
           benchmark-names)))

  ; Yet another LaTeX table

  (define (display-analysis data out)
    (format out "\\begin{tabular}{|l|rrrrr|}~%\\hline~%")
    (format out " & GEN & 1DOF & 2DOF & 3DOF & 4DOF \\\\~%")
    (format out "\\hline~%")
    ; Present sorted by benchmark name, then by number of iterations
    (for-each (lambda (datum)
                (format out " ~20a " (format-benchmark-name (car datum)))
                (for-each (lambda (n i)
                            (if (not (= (car n) i))
                                (error "Collectors not correctly sorted."))
                            (format out " & ~a " (or (cadr n) "")))
                          (cdr datum)
                          (iota 5))
                (format out "\\\\~%"))
              (sort data (lambda (a b) 
                           (benchmark<? (car a) (car b)))))
    (format out "\\hline~%")
    (format out "\\end{tabular}~%"))

  (load-dof-results)
  (load-gen-results)
  (if (null? rest)
      (display-analysis (mark/cons-analysis) (current-output-port))
      (call-with-output-file (car rest) 
        (lambda (out)
          (display-analysis (mark/cons-analysis) out)))))


; Float analysis
;
; Table of copy volume across benchmarks (down) and DOF collectors (across),
; for both full GC before DOF GC (left half) and full GC before any GC
; (right half), expressed as a percentage reduction relative to the
; canonical run. (Whew!)

(define (dof-float-analysis . rest)

  (define results '())                  ; ((bm setting) volume counter)

  (define (lookup bm setting)
    (let ((probe (assoc (list bm setting) results)))
      (if probe
          probe
          (let ((x (list (list bm setting) 0 0)))
            (set! results (cons x results))
            x))))

  (define (process-datum datum n)
    (if (all-iterations-succeeded? datum)
        (let* ((name (list n (cdr (assq 'benchmark-name datum))))
               (cell 
                (lookup 
                 name
                 (cond ((let ((x (assq '-dof-fullgc-on-collection datum)))
                          (and x (cdr x)))
                        'collect)
                       ((let ((x (assq '-dof-fullgc-on-promotion datum)))
                          (and x (cdr x)))
                        'promote)
                       (else 'normal)))))
          (set-car! (cdr cell) (+ (cadr cell) 
                                  (cdr (assq 'run-bytes-copied-best datum))
                                  (cdr (assq 'run-bytes-moved-best datum))))
          (set-car! (cddr cell) (+ (caddr cell) 1)))))

  (define (analyze tag all-data)        ; Returns assoc list ( tag . avg )
    (set! results '())
    (for-each-benchmark-result process-datum all-data)
    (map (lambda (x) 
           (cons (cons tag (car x)) (/ (cadr x) (caddr x))))
         results))

  (define (float-analysis)
    (let ((results 
           (append 
            (analyze 1 (1dof-float-canonical-data))
            (analyze 2 (2dof-float-canonical-data))
            (analyze 3 (3dof-float-canonical-data))
            (analyze 4 (4dof-float-canonical-data)))))
      (map (lambda (bm)
             (cons bm
                   (mappend 
                    (lambda (full)
                      (map 
                       (lambda (dof)
                         (let ((normal  (assoc (list dof bm 'normal) results))
                               (reduced (assoc (list dof bm full) results)))
                           (if (and normal reduced)
                               (list dof 
                                     (inexact->exact
                                      (round 
                                       (* 100.0 (- 1.0 (/ (cdr reduced)
                                                          (cdr normal)))))))
                               (list dof #f))))
                       (iota1 4)))
                    '(collect promote))))
           benchmark-names)))

  (define (display-analysis data out)
    (latex-table 
     out 
     "|l|rrrr|rrrr|"
     '(("" ("Full GC before DOF GC" 4) ("Full GC before every GC" 4))
       ("" "1DOF" "2DOF" "3DOF" "4DOF" "1DOF" "2DOF" "3DOF" "4DOF"))
     (cons 'benchmark-name (make-list 8 'num-cadr))
     (sort data (lambda (a b) (benchmark<? (car a) (car b))))))

  (load-dof-float-results)
  (load-dof-results)
  (if (null? rest)
      (display-analysis (float-analysis) (current-output-port))
      (call-with-output-file (car rest) 
        (lambda (out)
          (display-analysis (float-analysis) out)))))

; This is like above, but presents derived data: collection float and
; promotion float as a percentage increase in copying over the minimum.

(define (dof-float-analysis-derived . rest)

  (define results '())                  ; ((bm setting) volume counter)

  (define (lookup bm setting)
    (let ((probe (assoc (list bm setting) results)))
      (if probe
          probe
          (let ((x (list (list bm setting) 0 0)))
            (set! results (cons x results))
            x))))

  (define (process-datum datum n)
    (if (all-iterations-succeeded? datum)
        (let* ((name (list n (cdr (assq 'benchmark-name datum))))
               (cell 
                (lookup 
                 name
                 (cond ((let ((x (assq '-dof-fullgc-on-collection datum)))
                          (and x (cdr x)))
                        'collect)
                       ((let ((x (assq '-dof-fullgc-on-promotion datum)))
                          (and x (cdr x)))
                        'promote)
                       (else 'normal)))))
          (set-car! (cdr cell) (+ (cadr cell) 
                                  (cdr (assq 'run-bytes-copied-best datum))
                                  (cdr (assq 'run-bytes-moved-best datum))))
          (set-car! (cddr cell) (+ (caddr cell) 1)))))

  (define (analyze tag all-data)        ; Returns assoc list ( tag . avg )
    (set! results '())
    (for-each-benchmark-result process-datum all-data)
    (map (lambda (x) 
           (cons (cons tag (car x)) (/ (cadr x) (caddr x))))
         results))

  (define dec (decimals 1))

  (define (float-analysis full)
    (let ((results 
           (append 
            (analyze 1 (1dof-float-canonical-data))
            (analyze 2 (2dof-float-canonical-data))
            (analyze 3 (3dof-float-canonical-data))
            (analyze 4 (4dof-float-canonical-data))
            (analyze 5 (4dof-float-noncanonical-data)))))
      (map (lambda (bm)
             (cons bm
                   (map 
                    (lambda (dof)
                      (let ((prom (assoc (list dof bm 'promote) results))
                            (coll (assoc (list dof bm 'collect) results))
                            (norm (assoc (list dof bm 'normal) results)))
                        (case full
                          ((collect)
                           (if (and norm coll)
                               (list dof 
                                     (dec
                                      (* 100.0 (- (/ (cdr norm) (cdr coll))
                                                  1.0))))
                               (list dof #f)))
                          ((promote)
                           (if (and norm coll)
                               (list dof 
                                     (dec
                                      (* 100.0 (- (/ (cdr coll) (cdr prom))
                                                  1.0))))
                               (list dof #f))))))
                    (iota1 5))))
           benchmark-names)))

  ; Yet another LaTeX table

  (define (display-analysis data out)
    (format out "\\begin{tabular}{|l|rrrrr|}~%\\hline~%")
;    (format out " & \\multicolumn{4}{c|}{Collection float (\\%)} ")
;    (format out " & \\multicolumn{4}{c|}{Promotion float (\\%)} \\\\~%")
    (format out 
            " & 1DOF & 2DOF & 3DOF & 4DOF & 4DOF-NC \\\\~%")
    (format out "\\hline~%")
    ; Present sorted by benchmark name, then by number of iterations
    (for-each (lambda (datum)
                (format out "~20a " (format-benchmark-name (car datum)))
                (for-each (lambda (n i)
                            (if (not (= (car n) i))
                                (error "Collectors not correctly sorted."))
                            (format out " & ~4@a" (or (cadr n) "")))
                          (cdr datum)
                          (iota1 5))
                (format out "\\\\~%"))
              (sort data (lambda (a b)
                           (benchmark<? (car a) (car b)))))
    (format out "\\hline~%")
    (format out "\\end{tabular}~%"))

  (load-dof-float-results)
  (if (null? rest)
      (begin 
        (display-analysis (float-analysis 'collect) (current-output-port))
        (display-analysis (float-analysis 'promote) (current-output-port)))
      (call-with-output-file (car rest) 
        (lambda (out)
          (begin (display-analysis (float-analysis 'collect) out)
                 (display-analysis (float-analysis 'promote) out))))))

; Based on gen-float-report

(define (dof-collection-float-report)
  (let ((opt '(-dof-fullgc-on-collection . #t)))
    (let ((1dof-data (dof-float-analysis-core (1dof-float-data-normal)
                                              (1dof-float-data-reduced opt)))
          (2dof-data (dof-float-analysis-core (2dof-float-data-normal)
                                              (2dof-float-data-reduced opt)))
          (3dof-data (dof-float-analysis-core (3dof-float-data-normal)
                                              (3dof-float-data-reduced opt)))
          (4dof-data (dof-float-analysis-core (4dof-float-data-normal)
                                              (4dof-float-data-reduced opt)))
          (4nc-data (dof-float-analysis-core  (4dof-float-data-noncanonical)
                                              (4dof-float-data-reduced opt))))
      (dof-float-report 1dof-data 2dof-data 3dof-data 4dof-data 4nc-data))))


(define (dof-promotion-float-report)
  (let ((opt0 '(-dof-fullgc-on-collection . #t))
        (opt1 '(-dof-fullgc-on-promotion . #t)))
    (let ((1dof-data (dof-float-analysis-core (1dof-float-data-reduced opt0)
                                              (1dof-float-data-reduced opt1)))
          (2dof-data (dof-float-analysis-core (2dof-float-data-reduced opt0)
                                              (2dof-float-data-reduced opt1)))
          (3dof-data (dof-float-analysis-core (3dof-float-data-reduced opt0)
                                              (3dof-float-data-reduced opt1)))
          (4dof-data (dof-float-analysis-core (4dof-float-data-reduced opt0)
                                              (4dof-float-data-reduced opt1))))
      (dof-float-report 1dof-data 2dof-data 3dof-data 4dof-data '()))))


(define (dof-float-report 1dof-data 2dof-data 3dof-data 4dof-data 4nc-data)

  (define (cadr0 x) (if (not x) 0.0 (cadr x)))
  (define (caddr0 x) (if (not x) 0.0 (caddr x)))

  (latex-table
   (current-output-port)
   "|l|rr|rr|"
   '(("" ("Percent" 5) ("Volume" 5))
     ("" "1DOF" "2DOF" "3DOF" "4DOF" "4DOF-NC" "1DOF" "2DOF" "3DOF" "4DOF" "4DOF-NC"))
   (cons '(benchmark-name "~20a")
         (make-list 10 '(literal "~6,1f")))
   (map (lambda (bm)
          (let ((1normal (cadr0 (assoc bm 1dof-data)))
                (1reduced (caddr0 (assoc bm 1dof-data)))
                (2normal (cadr0 (assoc bm 2dof-data)))
                (2reduced (caddr0 (assoc bm 2dof-data)))  
                (3normal (cadr0 (assoc bm 3dof-data)))
                (3reduced (caddr0 (assoc bm 3dof-data)))
                (4normal (cadr0 (assoc bm 4dof-data)))
                (4reduced (caddr0 (assoc bm 4dof-data)))
                (4nc-normal (cadr0 (assoc bm 4nc-data)))
                (4nc-reduced (caddr0 (assoc bm 4nc-data))))
            (list bm
                  (* 100 (/ (- 1normal 1reduced) 1reduced))
                  (* 100 (/ (- 2normal 2reduced) 2reduced))
                  (* 100 (/ (- 3normal 3reduced) 3reduced))
                  (* 100 (/ (- 4normal 4reduced) 4reduced))
                  (* 100 (/ (- 4nc-normal 4nc-reduced) 4nc-reduced))
                  (/ (- 1normal 1reduced) (* 1024 1024))
                  (/ (- 2normal 2reduced) (* 1024 1024))
                  (/ (- 3normal 3reduced) (* 1024 1024))
                  (/ (- 4normal 4reduced) (* 1024 1024))
                  (/ (- 4nc-normal 4nc-reduced) (* 1024 1024)))))
        benchmark-names)))

(define (dof-float-analysis-core normal-data reduced-data)
  (map (lambda (x)
         (list (caar x) 
               (exact->inexact (mean (map cadr x)))
               (exact->inexact (mean (map caddr x)))))
       (accumulate-unordered
        (lambda (a b)
          (equal? (car a) (car b)))
        (call-with-accumulator
         (lambda (acc)
           (for-each-benchmark-result*
            (lambda (n a b)
              (if (and (all-iterations-succeeded? a)
                       (all-iterations-succeeded? b))
                  (acc (list (benchmark-designator a)
                             (+ (cdr (assq 'run-bytes-copied-best a))
                                (cdr (assq 'run-bytes-moved-best a)))
                             (+ (cdr (assq 'run-bytes-copied-best b))
                                (cdr (assq 'run-bytes-moved-best b)))))))
            normal-data
            reduced-data))))))


; Popular object analysis
;
; Table of number of remembered set inserts for 5nboyer, 5pnboyer, 5sboyer,
; and 5psboyer, averaged across all runs for a particular collector.

(define (dof-popular-object-analysis . rest)

  (define (select-runs data selector)
    (selector
     (dof-compute-canonical-data
      (remove-var-load-<-2.25 data))))

  (define (pick-benchmarks var-1 pvar-1 var-5 pvar-5)
    `((,(append (select-runs var-1 select-boyer)
                (select-runs pvar-1 identity))    1)
      (,(append (select-runs var-5 select-boyer)
                (select-runs pvar-5 identity))    5)))

  (define (select-boyer runs)
    (filter (lambda (x)
              (let ((probe (assq 'benchmark-name x)))
                (and probe
                     (memq (cdr probe) '(sboyer:3 sboyer:4 nboyer:3)))))
            runs))

  (define results '())

  (define (lookup tag)
    (let ((probe (assoc tag results)))
      (if probe
          probe
          (let ((probe (list tag 0 0)))
            (set! results (cons probe results))
            probe))))

  (define (process-datum datum n)
    (if (all-iterations-succeeded? datum)
        (let ((cell (lookup (list n (cdr (assq 'benchmark-name datum))))))
          (set-car! (cdr cell) (+ (cadr cell)
                                  (cdr (assq 'remset-entries-added-best
                                             datum))))
          (set-car! (cddr cell) (+ (caddr cell) 1)))))

  (define (analyze tag data)
    (set! results '())
    (for-each-benchmark-result process-datum data)
    (map (lambda (x)
           (cons (cons tag (car x)) (/ (cadr x) (caddr x))))
         results))

  (define (popular-analysis)
    (let ((results
           (append 
            (analyze 1 (pick-benchmarks 1dof-var-1 pboyer-1dof-var-1
                                        1dof-var-5 pboyer-1dof-var-5))
            (analyze 2 (pick-benchmarks 2dof-var-1 pboyer-2dof-var-1
                                        2dof-var-5 pboyer-2dof-var-5))
            (analyze 3 (pick-benchmarks 3dof-var-1 pboyer-3dof-var-1
                                        3dof-var-5 pboyer-3dof-var-5))
            (analyze 4 (pick-benchmarks 4dof-var-1 pboyer-4dof-var-1
                                        4dof-var-5 pboyer-4dof-var-5)))))
      ; Now match up
      (let ((matches `((sboyer:4 . psboyer:4)
                       (nboyer:3 . pnboyer:3))))
        (map 
         (lambda (bm)
           (cons bm
                 (map
                  (lambda (dof)
                    (let ((symbols (assoc (cons dof bm) results))
                          (indices (assoc (list dof 
                                                (car bm) 
                                                (cdr (assq (cadr bm) matches)))
                                          results)))
                      (if (and symbols indices)
                          (list dof (inexact->exact
                                     (round (* 100.0 (- 1.0 
                                                        (/ (cdr indices)
                                                           (cdr symbols)))))))
                          (list dof #f))))
                  (iota1 4))))
         '((1 nboyer:3) (5 nboyer:3) (5 sboyer:4))))))

  (define (display-analysis data out)
    (format out "\\begin{tabular}{|l|rrrr|}~%\\hline~%")
    (format out " & 1DOF & 2DOF & 3DOF & 4DOF \\\\~%")
    (format out "\\hline~%")
    ; Present sorted by benchmark name, then by number of iterations
    (for-each (lambda (datum)
                (format out " ~a " (format-benchmark-name (car datum)))
                (for-each (lambda (n i)
                            (if (not (= (car n) i))
                                (error "Collectors not correctly sorted."))
                            (format out " & ~a " (or (cadr n) "")))
                          (cdr datum)
                          (iota1 4))
                (format out "\\\\~%"))
              (sort data (lambda (a b)
                           (benchmark<? (car a) (car b)))))
    (format out "\\hline~%")
    (format out "\\end{tabular}~%"))

  (load-dof-pboyer-results)
  (load-dof-results)
  (if (null? rest)
      (display-analysis (popular-analysis) (current-output-port))
      (call-with-output-file (car rest) 
        (lambda (out)
          (display-analysis (popular-analysis) out)))))


; Remset analysis
;
; Table of peak remset size as a percentage of peak heap size (for that
; run), averaged over all runs for a particular benchmark and collector.

(define (dof-remset-analysis . rest)

;  (define (dof-remset-ratio datum)      ; n or #f (missing or invalid)
;    (cond ((not (all-iterations-succeeded? datum))
;           #f)
;          ((positive? (cdr (assq 'run-cpu-gc-full-best datum)))
;           ; Full GC was run -- assume field is invalid (would be nice
;           ; to have an indicator whether field was estimated or not)
;           #f)
;          (else
;           (* 100.0 (/ (cdr (assq 'bytes-max-remset datum))
;                       (cdr (assq 'bytes-max-heap datum)))))))

;  (define (gen-remset-ratio datum)      ; n or #f (missing)
;    (cond ((not (all-iterations-succeeded? datum))
;           #f)
;          (else
;           (* 100.0 (/ (cdr (assq 'bytes-max-remset datum))
;                       (cdr (assq 'bytes-max-heap datum)))))))

  (define megabyte (* 1024 1024))

  ; For the peculiar second clause, see the comments to
  ; do-4dof-remset-size-canonical-data, above.

  (define (dof-remset-ratio datum)      ; n or #f (missing)
    (cond ((not (all-iterations-succeeded? datum))
           #f)
          ((and (positive? (cdr (assq 'run-cpu-gc-full-best datum)))
                (member (gc-designator datum)
                        '((dof 1) (dof 2) (dof 3))))
           ; Full GC was run -- assume field is invalid (would be nice
           ; to have an indicator whether field was estimated or not)
           #f)
          (else
           (/ (cdr (assq 'bytes-max-remset datum)) megabyte))))

  (define (gen-remset-ratio datum)      ; n or #f (missing)
    (cond ((not (all-iterations-succeeded? datum))
           #f)
          (else
           (/ (cdr (assq 'bytes-max-remset datum)) megabyte))))

  (define results '())

  (define (lookup tag)
    (let ((probe (assoc tag results)))
      (if probe
          probe
          (let ((probe (list tag 0 0)))
            (set! results (cons probe results))
            probe))))

  (define (process-datum datum processor iter)
    (let ((n (processor datum)))
      (if n
          (let ((cell (lookup (list iter (cdr (assq 'benchmark-name datum))))))
            (set-car! (cdr cell) (+ (cadr cell) n))
            (set-car! (cddr cell) (+ (caddr cell) 1))))))

  (define (analyze tag all-data processor)
    (set! results '())
    (for-each-benchmark-result (lambda (datum iter)
                                 (process-datum datum processor iter))
                               all-data)
    (map (lambda (x) 
           (cons (cons tag (car x)) (/ (cadr x) (caddr x))))
         results))

  (define (remset-analysis)
    (let ((results
           (append (analyze 0 (2gen-canonical-data) gen-remset-ratio)
                   (analyze 1 (1dof-canonical-data) dof-remset-ratio)
                   (analyze 2 (2dof-canonical-data) dof-remset-ratio)
                   (analyze 3 (3dof-canonical-data) dof-remset-ratio)
                   (analyze 4 (4dof-remset-size-canonical-data) dof-remset-ratio)
                   (analyze 5 (4dof-noncanonical-data) dof-remset-ratio))))
      (map (lambda (bm)
             (cons bm
                   (map
                    (lambda (gc)
                      (let ((probe (assoc (cons gc bm) results)))
                        (if probe
                            (list gc (cdr probe))
                            (list gc #f))))
                    (iota 6))))
           benchmark-names)))

  (define (display-analysis data out)
    (format out "\\begin{tabular}{|l|rrrrrr|}~%\\hline~%")
    (format out " & 2GEN & 1DOF & 2DOF & 3DOF & 4DOF & 4DOF-NC \\\\~%")
    (format out "\\hline~%")
    ; Present sorted by benchmark name, then by number of iterations
    (for-each (lambda (datum)
                (format out "~20a " (format-benchmark-name (car datum)))
                (for-each (lambda (n i)
                            (if (not (= (car n) i))
                                (error "Collectors not correctly sorted."))
                            (format out "& ~5,2f " (or (cadr n) "")))
                          (cdr datum)
                          (iota 6))
                (format out "\\\\~%"))
              (sort data (lambda (a b)
                           (benchmark<? (car a) (car b)))))
    (format out "\\hline~%")
    (format out "\\end{tabular}~%"))

  (load-dof-results)
  (load-gen-results)
  (if (null? rest)
      (display-analysis (remset-analysis) (current-output-port))
      (call-with-output-file (car rest) 
        (lambda (out)
          (display-analysis (remset-analysis) out)))))

; Remset activity analysis
;
; Table of remset insertions, removals (for qualitative analysis).

(define (dof-remset-activity-analysis . rest)

  (define results '())

  (define (lookup tag)
    (let ((probe (assoc tag results)))
      (if probe
          probe
          (let ((probe (list tag 0 0 0 0 0))) ; insert remove count scan wscan
            (set! results (cons probe results))
            probe))))

  (define (get x n) (list-ref x n))
  (define (put x n v) (list-set! x n (+ (list-ref x n) v)))

  (define (rinsert x . rest) (if (null? rest) (get x 1) (put x 1 (car rest))))
  (define (rremove x . rest) (if (null? rest) (get x 2) (put x 2 (car rest))))
  (define (rcount x . rest) (if (null? rest) (get x 3) (put x 3 (car rest))))
  (define (rscan x . rest) (if (null? rest) (get x 4) (put x 4 (car rest))))
  (define (rwscan x . rest) (if (null? rest) (get x 5) (put x 5 (car rest))))
  
  (define (process-datum datum iter)
    (if (all-iterations-succeeded? datum)
        (let ((cell (lookup 
                     (list iter (cdr (assq 'benchmark-name datum))))))
          (rinsert cell (cdr (assq 'run-remset-entries-added-best datum)))
          (rremove cell (cdr (assq 'run-remset-entries-removed-best datum)))
          (rcount cell 1)
          (rscan cell (cdr (assq 'run-remset-entries-scanned-best datum)))
          (rwscan cell (/ (cdr (assq 'run-remset-bytes-scanned-best datum)) 
                          4)))))

  (define (analyze tag all-data)
    (set! results '())
    (for-each-benchmark-result process-datum all-data)
    (map (lambda (x)                    
           ; Note, compatible representation!
           (list (cons tag (car x))
                 (/ (rinsert x) (rcount x))
                 (/ (rremove x) (rcount x))
                 (rcount x)
                 (/ (rscan x) (rcount x))
                 (/ (rwscan x) (rcount x))))
         results))

  (define d (decimals 1))

  (define (remset-analysis)
    (let ((results
           (append (analyze 0 (2gen-canonical-data))
                   (analyze 1 (1dof-canonical-data))
                   (analyze 2 (2dof-canonical-data))
                   (analyze 3 (3dof-canonical-data))
                   (analyze 4 (4dof-canonical-data))
                   (analyze 5 (4dof-noncanonical-data)))))
      (map (lambda (bm)
             (cons bm
                   (map
                    (lambda (gc)
                      (let ((probe (assoc (cons gc bm) results)))
                        (if probe
                            ; Note, compatible representation!
                            (list gc 
                                  (d (rinsert probe))
                                  (d (rremove probe))
                                  (rcount probe)
                                  (d (rscan probe))
                                  (d (rwscan probe)))
                            (list gc #f #f #f #f #f))))
                    (iota 6))))
           benchmark-names)))

  (define (sci3 x)
    (if (not x)
        ""
        (format-byte-volume.1 x)))

  ; Break by datum reported: one table per datum, six collectors
  ; (including 4DOF-NC).  That way it's easier to compare the same
  ; number across collectors, which is the typical use.

  (define (display-analysis name data out f)
    (format out "\\begin{tabular}{|l|rrrrrr|}~%\\hline~%")
    (format out " & \\multicolumn{6}{c|}{~a} \\\\~%" name)
    (format out " & 2GEN & 1DOF & 2DOF & 3DOF & 4DOF & 4DOF-NC \\\\~%")
    (format out "\\hline~%")
    (for-each (lambda (datum)
                (format out " ~20a " (format-benchmark-name (car datum)))
                (for-each (lambda (n i)
                            (if (not (= (car n) i))
                                (error "Collectors not correctly sorted."))
                            (format out "& ~7@a " (sci3 (f n))))
                          (cdr datum)
                          (iota 6))
                (format out "\\\\~%"))
              (sort data (lambda (a b)
                           (benchmark<? (car a) (car b)))))
    (format out "\\hline~%")
    (format out "\\end{tabular}~%"))


  (define (show-results results out)
    (do ((f '("Objects inserted" "Objects scanned" "Words scanned") (cdr f))
         (k '(1 4 5) (cdr k)))
        ((null? f))
      (display-analysis (car f) results out (lambda (x)
                                              (list-ref x (car k))))))

  (load-dof-results)
  (load-gen-results)
  (if (null? rest)
      (show-results (remset-analysis) (current-output-port))
      (call-with-output-file (car rest) 
        (lambda (out)
          (show-results (remset-analysis) out)))))


; Returns a list: (bm copied moved)

;(define (dof-extract-promotion/collection-volume)
;  (load-dof-promvol-results)
;  (append (extract-promotion/collection-volume
;           (basic-statistics promvol-4dof-var-1))
;          (extract-promotion/collection-volume
;           (basic-statistics promvol-4dof-var-5))))

;(define (dof-extract-promotion/collection-cost)
;  (load-dof-results)
;  (let ((r1 (basic-statistics 4dof-var-1))
;        (r2 (basic-statistics 4dof-var-5)))
;    (map (lambda (x)
;           (list (caar x) 
;                 (mean (map cadr x))
;                 (mean (map caddr x))))
;         (accumulate-unordered
;          (lambda (a b)
;            (equal? (car a) (car b)))
;          (filter-map (lambda (x)
;                        (if (all-iterations-succeeded? x)
;                            (list (benchmark-designator x)
;                                  (cdr (assq 'run-cpu-gc-promote-best x))
;                                  (cdr (assq 'run-cpu-gc-collect-best x)))
;                            #f))
;                      (append r1 r2))))))

(define (dof-extract-promotion/collection-volume)
  (load-dof-promvol-results)
  (append (extract-promotion/collection-volume
           (dof-compute-data-for-ff-s/ns 1 #f promvol-4dof-var-1))
          (extract-promotion/collection-volume
           (dof-compute-data-for-ff-s/ns 1 #f promvol-4dof-var-5))))

(define (dof-extract-promotion/collection-cost)
  (load-dof-results)
  (let ((r1 (dof-compute-canonical-data 4dof-var-1))
        (r2 (dof-compute-canonical-data 4dof-var-5)))
    (map (lambda (x)
           (list (caar x) 
                 (mean (map cadr x))
                 (mean (map caddr x))))
         (accumulate-unordered
          (lambda (a b)
            (equal? (car a) (car b)))
          (filter-map (lambda (x)
                        (if (all-iterations-succeeded? x)
                            (list (benchmark-designator x)
                                  (cdr (assq 'run-cpu-gc-promote-best x))
                                  (cdr (assq 'run-cpu-gc-collect-best x)))
                            #f))
                      (append r1 r2))))))

; Computes the cost of promotion (ms/MB).

(define (dof-promotion/collection-cost)
  (let ((v (dof-extract-promotion/collection-volume))
        (c (dof-extract-promotion/collection-cost)))
    (map (lambda (x)
           (let ((y (cdr (assoc (car x) v))))
             (list (car x)
                   (exact->inexact (/ (cadr x) 
                                      (/ (+ (caar y) (cdar y))
                                         (* 1024 1024))))
                   (exact->inexact (/ (caddr x)
                                      (/ (+ (caadr y) (cdadr y))
                                         (* 1024 1024)))))))
         c)))


; This may be of some interest.

(define (dof-actual-survival-rate)
  (map (lambda (d)
	 (list (car d)
	       (/ (+ (caadr d) (cdadr d))
		  (canonical-allocation (car d)))))
       (dof-extract-promotion/collection-volume)))

; Computes the amount copied by DOF collector on the float reduction run
; by subtracting the promotion volume (obtained separately) from the
; total amount copied.  This works because the promotion volume is constant
; across DOF collectors.

(define (report-dof-copy-volume-with-float-reduction)
  (define (b->mb x)
    (/ x (* 1024 1024)))

  (define (report out)
    (let ((results (dof-copy-volume-with-float-reduction)))
      (format out "\\begin{tabular}{|l|rrrrrr|}~%\\hline~%")
      (format out " & Copying & Copying   & Promotion & DOF & DOF (\\%) & Actual \\\\~%")
      (format out " &         & (reduced) &           &     & (reduced) & float \\\\~%")
      (format out "\\hline~%")
      (for-each (lambda (x)
                  (format out "~20a & ~5,1f & ~5,1f & ~5,1f & ~5,1f & ~5,1f & ~5@a\\% \\\\~%"
                          (format-benchmark-name (car x))
                          (b->mb (cadr x))
                          (b->mb (caddr x))
                          (b->mb (cadddr x))
                          (b->mb (car (cddddr x)))
                          (b->mb (cadr (cddddr x)))
                          (inexact->exact
                           (round 
                            (* 100.0 (/ (- (car (cddddr x)) (cadr (cddddr x)))
                                        (cadr (cddddr x))))))))
                (sort results (lambda (a b) (benchmark<? (car a) (car b)))))
      (format out "\\hline~%")
      (format out "\\end{tabular}~%")))
  (report (current-output-port)))

(define (dof-copy-volume-with-float-reduction)
  (let ((promvol (dof-extract-promotion/collection-volume))
        (floatvol (dof-extract-float-reduced-copy-volumes 'collect))
        (normvol (dof-extract-float-reduced-copy-volumes 'normal)))
    (map (lambda (a)
           (let* ((b (assoc (car a) floatvol))
                  (c (assoc (car a) normvol))
                  (diff (exact->inexact (- (cadr b) (car (cadr a))))))
             (list (car a)
                   (cadr c)             ; Total copying, normal
                   (cadr b)             ; Total copying, with float reduction
                   (car (cadr a))       ; Total copying by promotion
                   (- (cadr c) (car (cadr a))) ; DOF, with float reduction
                   diff)))              ; float reduced - promotion = DOF
         promvol)))

(define (dof-extract-float-reduced-copy-volumes type)
  (load-dof-float-results)
  (load-dof-results)
  (let ((data
         (case type
           ((normal)
            `((,(flatten-option-noise 
                 (basic-statistics 4dof-upper+lower-1)) 1)
              (,(flatten-option-noise 
                 (basic-statistics 4dof-upper+lower-5)) 5)))
           ((collect)
            `((,(flatten-option-noise 
                 (basic-statistics float-4dof-upper+lower-1)) 1)
              (,(flatten-option-noise 
                 (basic-statistics float-4dof-upper+lower-5)) 5)))
           (else ???))))
    (map (lambda (x)
           (list (caar x) (exact->inexact (mean (map cadr x)))))
         (accumulate-unordered
          (lambda (a b) (equal? (car a) (car b)))
          (filter-map-benchmark-result
           (lambda (bs n)
             (if (and (all-iterations-succeeded? bs)
                      (or (and (eq? type 'collect)
                               (let ((x (assq '-dof-fullgc-on-collection bs)))
                                 (and x (cdr x))))
                          (and (eq? type 'normal)
                               (let ((x (assq '-dof-fullgc-on-collection bs))
                                     (y (assq '-dof-fullgc-on-promotion bs)))
                                 (and (or (not x) (not (cdr x)))
                                      (or (not y) (not (cdr y))))))))
                 (list (benchmark-designator bs)
                       (cdr (assq 'run-bytes-copied-best bs)))
                 #f))
           data)))))

; Efficacy of full GC

(define (dof-fullgc-analysis prefix)
  (load-dof-results)
  (let ((1dof-true (list (1dof-canonical-data-for-ff 1)))
        (1dof-false (list (1dof-canonical-data-for-ff 0)))
        (2dof-true (list (2dof-canonical-data-for-ff 1)))
        (2dof-false (list (2dof-canonical-data-for-ff 0)))
        (3dof-true (list (3dof-canonical-data-for-ff 1)))
        (3dof-false (list (3dof-canonical-data-for-ff 0)))
        (4dof-true (list (4dof-canonical-data-for-ff 1)))
        (4dof-false (list (4dof-canonical-data-for-ff 0))))

    (all-benchmarks-gnuplot-report
     (string-append prefix "ff-cpu-gc-time1.data")
     (compare-all-by-cpu-gc-time 1dof-true 1dof-false))
                               
    (all-benchmarks-gnuplot-report
     (string-append prefix "ff-cpu-gc-time2.data")
     (compare-all-by-cpu-gc-time 2dof-true 2dof-false))

    (all-benchmarks-gnuplot-report
     (string-append prefix "ff-cpu-gc-time3.data")
     (compare-all-by-cpu-gc-time 3dof-true 3dof-false))

    (all-benchmarks-gnuplot-report
     (string-append prefix "ff-cpu-gc-time4.data")
     (compare-all-by-cpu-gc-time 4dof-true 4dof-false))

    (report-box-and-line-by-benchmark
     compare-benchmarks-by-cpu-gc-time
     (string-append prefix "bm-ff-cpu-gc-time1.tex")
     1dof-true 1dof-false)

    (report-box-and-line-by-benchmark
     compare-benchmarks-by-cpu-gc-time
     (string-append prefix "bm-ff-cpu-gc-time2.tex")
     2dof-true 2dof-false)

    (report-box-and-line-by-benchmark
     compare-benchmarks-by-cpu-gc-time
     (string-append prefix "bm-ff-cpu-gc-time3.tex")
     3dof-true 3dof-false)

    (report-box-and-line-by-benchmark
     compare-benchmarks-by-cpu-gc-time
     (string-append prefix "bm-ff-cpu-gc-time4.tex")
     4dof-true 4dof-false)))

; Efficacy of shadow remembered sets

(define (dof-shadow-set-analysis prefix)
  (load-dof-results)
  (let ((1dof-true (list (1dof-canonical-data-for-s/ns #t)))
        (1dof-false (list (1dof-canonical-data-for-s/ns #f)))
        (2dof-true (list (2dof-canonical-data-for-s/ns #t)))
        (2dof-false (list (2dof-canonical-data-for-s/ns #f)))
        (3dof-true (list (3dof-canonical-data-for-s/ns #t)))
        (3dof-false (list (3dof-canonical-data-for-s/ns #f)))
        (4dof-true (list (4dof-canonical-data-for-s/ns #t)))
        (4dof-false (list (4dof-canonical-data-for-s/ns #f))))

    (all-benchmarks-gnuplot-report
     (string-append prefix "shadow-cpu-gc-time1.data")
     (compare-all-by-cpu-gc-time 1dof-true 1dof-false))
                               
    (all-benchmarks-gnuplot-report
     (string-append prefix "shadow-cpu-gc-time2.data")
     (compare-all-by-cpu-gc-time 2dof-true 2dof-false))

    (all-benchmarks-gnuplot-report
     (string-append prefix "shadow-cpu-gc-time3.data")
     (compare-all-by-cpu-gc-time 3dof-true 3dof-false))

    (all-benchmarks-gnuplot-report
     (string-append prefix "shadow-cpu-gc-time4.data")
     (compare-all-by-cpu-gc-time 4dof-true 4dof-false))

    (report-box-and-line-by-benchmark
     compare-benchmarks-by-cpu-gc-time
     (string-append prefix "bm-shadow-cpu-gc-time1.tex")
     1dof-true 1dof-false)

    (report-box-and-line-by-benchmark
     compare-benchmarks-by-cpu-gc-time
     (string-append prefix "bm-shadow-cpu-gc-time2.tex")
     2dof-true 2dof-false)

    (report-box-and-line-by-benchmark
     compare-benchmarks-by-cpu-gc-time
     (string-append prefix "bm-shadow-cpu-gc-time3.tex")
     3dof-true 3dof-false)

    (report-box-and-line-by-benchmark
     compare-benchmarks-by-cpu-gc-time
     (string-append prefix "bm-shadow-cpu-gc-time4.tex")
     4dof-true 4dof-false)))

(define (dof-ff-s/ns-averages field-name name0 name1 . rest)

  (define dof-processors
    (list do-1dof-canonical-data
          do-2dof-canonical-data
          do-3dof-canonical-data
          do-4dof-canonical-data))

  (define (get x) 
    (cdr (assq field-name x)))

  (define (analyze ff.1 s/ns.1 ff.2 s/ns.2)
    (map (lambda (dof-processor)
           (compare-by-benchmark 
            get 
            get
            (list (dof-processor
                   (lambda (data)
                     (dof-compute-data-for-ff-s/ns ff.1 s/ns.1 data))))
            (list (dof-processor
                   (lambda (data)
                     (dof-compute-data-for-ff-s/ns ff.2 s/ns.2 data))))
            identity))
         dof-processors))

  (define (average res)
    (map (lambda (outer)
           (map (lambda (inner)
                  (list (car inner) 
                        (weighted-mean (cdr inner) car cdr)))
                outer))
         res))

  (define (report out r0 r1)
    (format out "\\begin{tabular}{|l|rr|rr|rr|rr|}~%")
    (format out "\\hline~%")
    (do ((i 0 (+ i 1)))
        ((= i 4))
      (format out " & \\multicolumn{2}{c|}{~aDOF}" (+ i 1)))
    (format out "\\\\~%")
    (format out " & ~a & ~a & ~a & ~a & ~a & ~a & ~a & ~a \\\\~%"
            name0 name1 name0 name1 name0 name1 name0 name1)
    (for-each (lambda (bm)
                (format out "~20a" (format-benchmark-name bm))
                (do ((i 0 (+ i 1)))
                    ((= i 4))
                  (format out " & ~5,2f & ~5,2f" 
                          (cond ((assoc bm (list-ref r0 i)) => cadr)
                                (else ""))
                          (cond ((assoc bm (list-ref r1 i)) => cadr)
                                (else ""))))
                (format out " \\\\~%"))
              (sort benchmark-names benchmark<?))
    (format out "\\hline~%")
    (format out "\\end{tabular}~%"))

  (load-dof-results)
  (let ((r0 (average (apply analyze (car rest))))
        (r1 (average (apply analyze (cadr rest)))))
    (report (current-output-port) r0 r1)))

; Negative numbers means advantage for Shadow=0.

(define (dof-shadow-set-averages . rest)
  (let ((field-name (if (null? rest) 
                        'run-cpu-gc-best
                        (car rest))))
    (dof-ff-s/ns-averages field-name "FF=0" "FF=1" '(0 #f 0 #t) '(1 #f 1 #t))))

; Negative numbers means advantage for FF=0.

(define (dof-full-gc-averages . rest)
  (let ((field-name (if (null? rest) 
                        'run-cpu-gc-best
                        (car rest))))
    (dof-ff-s/ns-averages field-name "NS" "S" '(0 #f 1 #f) '(0 #t 1 #t))))


; Compare collectors

(define (dof-vs-dof prefix)
  (load-dof-results)
  (let ((1dof-data (all-1dof-canonical-data))
        (2dof-data (all-2dof-canonical-data))
        (3dof-data (all-3dof-canonical-data))
        (4dof-data (all-4dof-canonical-data)))

    (define combinations
      '((1 2) (1 3) (1 4) (2 3) (2 4) (3 4)))

    (define dof-data
      (vector 1dof-data 2dof-data 3dof-data 4dof-data))

    (for-each 
     (lambda (c)
       (let* ((a (car c))
              (a-data (vector-ref dof-data (- a 1)))
              (b (cadr c))
              (b-data (vector-ref dof-data (- b 1))))
;         (all-benchmarks-gnuplot-report
;          (format #f "~acpu-gc-time-~a-~a.data" prefix a b)
;          (compare-all-by-cpu-gc-time a-data b-data))

         (all-benchmarks-gnuplot-report
          (format #f "~aspace-~a-~a.data" prefix a b)
          (compare-all-by-space a-data b-data))

;         (report-box-and-line-by-benchmark
;          compare-benchmarks-by-cpu-gc-time
;          (format #f "~abm-cpu-gc-time-~a-~a.tex" prefix a b)
;          a-data b-data)
         ))
     combinations)))

; Experimental!
;
; Visualize a box 200 units to the side, centered at the origin.
; The corners are: 1dof, upper right
;                  2dof, lower right
;                  3dof, lower left
;                  4dof, upper left
; Relative results are plotted along the line (including diagonals) 
; that connect two collectors, so 1dof-vs-4dof is plotted on the upper
; horizontal line.  The diagonals are also 200 units long -- they're just
; larger units.
; So if X has a n% advantage over Y, then it is plotted at n at the side
; of X at the line.  If n > 100, then it is pinned at 100.
;
; One plot per benchmark.
;
; GNUplot probably can't handle this.

(define (test-part-1)
  (dof-vs-dof-all "/dev/tty"))

(define (test-part-2)
  (call-with-output-file "foo.tex"
    (lambda (out)
      (format out "\\documentclass{article}~%\\begin{document}~%")
      (latex-plot out 1500.0 1500.0 7.5 -100.0 100.0 100.0 -100.0 commands)
      (format out "\\end{document}~%"))))

(define (dof-vs-dof-all prefix)
  (load-dof-results)
  (do ((bms benchmark-names (cdr bms)))
      ((null? bms))
    (let* ((bm (car bms))
           (1dof-data (all-1dof-canonical-data (list bm)))
           (2dof-data (all-2dof-canonical-data (list bm)))
           (3dof-data (all-3dof-canonical-data (list bm)))
           (4dof-data (all-4dof-canonical-data (list bm))))

      (define combinations
        '((1 2) (1 3) (1 4) (2 3) (2 4) (3 4)))

      (define dof-data
        (vector 1dof-data 2dof-data 3dof-data 4dof-data))

      (call-with-4gc-plot
       (lambda (p)
         (display bm)
         (newline)
         (for-each 
          (lambda (c)
            (let* ((a (car c))
                   (a-data (vector-ref dof-data (- a 1)))
                   (b (cadr c))
                   (b-data (vector-ref dof-data (- b 1))))
              (draw-4gc-results 
               p a b
               (compare-all-by-cpu-gc-time a-data b-data))))
          combinations)
         (call-with-output-file 
             (string-append prefix
                            (number->string (car bm))
                            (sanitize-string (symbol->string (cadr bm)))
                            ".tex")
           (lambda (out)
             (latex-plot out 
                         1500.0 1500.0 7.5 
                         -100.0 100.0 100.0 -100.0 
                         p))))))))

(define (call-with-4gc-plot proc)
  (let ((plot (make-latex-plot)))
    ((plot 'line) -100.0 100.0 100.0 100.0)
    ((plot 'line) 100.0 100.0 100.0 -100.0)
    ((plot 'line) 100.0 -100.0 -100.0 -100.0)
    ((plot 'line) -100.0 -100.0 -100.0 100.0)
    ((plot 'line) -100.0 100.0 100.0 -100.0)
    ((plot 'line) -100.0 -100.0 100.0 100.0)
    ((plot 'text-left) -100.0 100.0 "4DOF ")
    ((plot 'text-left) -100.0 -100.0 "3DOF ")
    ((plot 'text-right) 100.0 100.0 " 1DOF")
    ((plot 'text-right) 100.0 -100.0 " 2DOF")
    (proc plot)
    plot))

; a and b are collector numbers, 1 thru 4
; results are pairs: xoffset, magnitude
; (a,b) = (b,a), and only one call with any (a,b) pair is allowed
; a != b always

(define (draw-4gc-results plot a b results)

  (define sqrt2 (sqrt 2.0))
  (define width 2.0)
  (define pi (acos -1.0))

  (define (rotate-by-45 x y)
    (rotate (* #i1/4 pi) x y))

  (define (rotate-by-90 x y)
    (rotate (* #i1/2 pi) x y))

  (define (rotate-by-135 x y)
    (rotate (* #i3/4 pi) x y))

  (define (rotate-by-180 x y)
    (rotate pi x y))

  (define (rotate-by-270 x y)
    (rotate (* #i3/2 pi) x y))

  (define (rotate a x y)
    (let ((d (sqrt (+ (square x) (square y))))
          (b (atan y x)))
      (values (* d (cos (+ a b)))
              (* d (sin (+ a b))))))

  (define translators
    `#(,(lambda (x y) (rotate-by-270 x (+ y 100.0)))
       ,(lambda (x y) (rotate-by-45 (* x sqrt2) y))
       ,(lambda (x y) (values x (+ 100.0 y)))
       ,(lambda (x y) (rotate-by-180 x (+ y 100.0)))
       ,(lambda (x y) (rotate-by-135 (* x sqrt2) y))
       ,(lambda (x y) (rotate-by-90 x (+ y 100.0)))))

  (define (translator a b)
    (vector-ref translators (select a b)))

  (define (tline trans x0 y0 x1 y1)
    (let-values (((x0 y0) (trans x0 y0))
                 ((x1 y1) (trans x1 y1)))
      ((plot 'line) x0 y0 x1 y1)))

  (define (box-at a b x-offset magnitude)
    (let ((trans (translator a b)))
      (tline trans
             (+ x-offset (/ width 2.0)) 0.0
             (+ x-offset (/ width 2.0)) (* magnitude 10))
      (tline trans
             (+ x-offset (/ width 2.0)) (* magnitude 10)
             (- x-offset (/ width 2.0)) (* magnitude 10))
      (tline trans
             (- x-offset (/ width 2.0)) (* magnitude 10)
             (- x-offset (/ width 2.0)) 0.0)))

  ; (x y) is in this list if xDOF is to the left of yDOF on the
  ; line that connects the two.

  (define less
    '((4 1) (3 4) (2 3) (1 2) (3 1) (2 4)))

  (define (select a b)
    (cond ((and (= a 1) (= b 2)) 0)
          ((and (= a 3) (= b 1)) 1)
          ((and (= a 4) (= b 1)) 2)
          ((and (= a 2) (= b 3)) 3)
          ((and (= a 2) (= b 4)) 4)
          ((and (= a 3) (= b 4)) 5)
          (else (error "Bogus: " (list a b)))))

  (let ((less? (member (list a b) less)))
    (let ((a      (if less? a b))
          (b      (if less? b a))
          (a-sign (if less? 1.0 -1.0))
          (at-min 0)
          (at-max 0))
      (for-each (lambda (r)
                  (let ((xoffs (car r))
                        (magn (cdr r)))
                    (cond ((<= (* a-sign xoffs) -100.0)
                           (set! at-min (+ at-min magn)))
                          ((>= (* a-sign xoffs) 100.0)
                           (set! at-max (+ at-max magn)))
                          (else
                           (box-at a b (* a-sign xoffs) magn)))))
                results)
      (if (> at-min 0)
          (box-at a b -100.0 at-min))
      (if (> at-max 0)
          (box-at a b 100.0 at-max)))))
        

;;

; The DOF results are too voluminous to be printed in their entirety
; (estimate about 120 pages).  The summary tables are a subset of data
; where for each benchmark setting, the best from the set of four
; (FF={0,1},S={0,1}) is selected and printed along with the ff/s setting.

; For each setting, select the best FF/S combination.
; Must be run on the _output_ of flatten-option-noise, below.

; Obsolete!  Use dof-data-reduction-canonical-run

(define (dof-data-reduction-best-of-four data)

  (define (cpu-best x)
    (let ((probe (assq 'cpu-best x)))
      (if probe
          (cdr probe)
          1000000000)))                 ; failed

  (select-most-desirable-run-and-resort data 
   (lambda (a b)
     (< (cpu-best a) (cpu-best b)))))


; Select canonical run.  Canonical run is hand-selected based on
; analysis of the results, before comparison with other collector's runs.
;
; Canonical runs were selected by the procedure below; see that for
; further information.

(define (dof-data-reduction-canonical-run data)
  (let ((n (dof-data-selection-dof-generations (car data))))
    (select-most-desirable-run-and-resort data
     (case n
       ((1) (ff/s-selector 0 #t))
       ((2) (ff/s-selector 0 #t))
       ((3) (ff/s-selector 0 #t))
       ((4) (ff/s-selector 1 #t))
       (else ???)))))

(define (dof-data-reduction-canonical-for-ff ff data)
  (let ((n (dof-data-selection-dof-generations (car data))))
    (select-most-desirable-run-and-resort data
     (case n
       ((1) (ff/s-selector ff #t))
       ((2) (ff/s-selector ff #t))
       ((3) (ff/s-selector ff #t))
       ((4) (ff/s-selector ff #t))
       (else ???)))))

(define (dof-data-reduction-canonical-for-s/ns s/ns data)
  (let ((n (dof-data-selection-dof-generations (car data))))
    (select-most-desirable-run-and-resort data
     (case n
       ((1) (ff/s-selector 0 s/ns))
       ((2) (ff/s-selector 0 s/ns))
       ((3) (ff/s-selector 0 s/ns))
       ((4) (ff/s-selector 1 s/ns))
       (else ???)))))

; Nothing canonical about this.

(define (dof-data-reduction-for-ff-s/ns ff s/ns data)
  (let ((n (dof-data-selection-dof-generations (car data))))
    (select-most-desirable-run-and-resort data
     (case n
       ((1) (ff/s-selector ff s/ns))
       ((2) (ff/s-selector ff s/ns))
       ((3) (ff/s-selector ff s/ns))
       ((4) (ff/s-selector ff s/ns))
       (else ???)))))

(define (dof-data-selection-dof-generations datum)
  (let ((x (assq 'system-info datum)))
    (if (not x)
        (error "Where are the settings in " datum))
    (cond ((member '(dof 1) (cdr x)) 1)
          ((member '(dof 2) (cdr x)) 2)
          ((member '(dof 3) (cdr x)) 3)
          ((member '(dof 4) (cdr x)) 4)
          (else (error "This doesn't look like a DOF collector to me: "
                       datum)))))

; -dof-full-frequency and -dof-no-shadow-remsets are always
; present, even in failed runs.

(define (ff/s-selector ff s)
  (lambda (a b)
    (let ((ff-a (cdr (assq '-dof-fullgc-frequency a)))
          (ff-b (cdr (assq '-dof-fullgc-frequency b)))
          (s-a  (not (cdr (assq '-dof-no-shadow-remsets a))))
          (s-b  (not (cdr (assq '-dof-no-shadow-remsets b)))))
      (and (eqv? ff ff-a)
           (eqv? s s-a)
           (not (and (eqv? ff ff-b)
                     (eqv? s s-b)))))))


; For each setting (00,01,10,11) pick the one of the four that is the 
; best and add 1 to the counter for that setting.  Returns the list
; of counters.  FF is high bit, S/NS is low bit

; On the draft data set, it returns
;
;   ((47 68 0 0)     1dof:  FF=0, S=1
;    (58 66 15 6)    2dof:  FF=0, S=1
;    (60 28 25 34)   3dof:  FF=0, S=0
;    (65 22 39 23))  4dof:  FF=0, S=0
;
; It might be useful to factor in space, somehow.

'(define (dof-analyze-for-canonical-run data)

  (define counters (vector 0 0 0 0))

  ; Run-cpu-best also works correctly on the ...-1 runs.
  (let ((data (select-most-desirable-run-and-resort 
               data
               (lambda (a b)
                 (and (all-iterations-succeeded? a)
                      (or (not (all-iterations-succeeded? b))
                          (< (cdr (assq 'run-cpu-best a))
                             (cdr (assq 'run-cpu-best b)))))))))
    (for-each (lambda (x)
                (if (all-iterations-succeeded? x)
                    (let ((n (+ (* 2 (cdr (assq '-dof-fullgc-frequency x)))
                                (if (cdr (assq '-dof-no-shadow-remsets x))
                                    0
                                    1))))
                      (vector-set! counters n 
                                   (+ (vector-ref counters n) 1)))))
              data)
    (vector->list counters)))

(define (dof-analysis-for-canonical-run)

  (define (process x)
    (apply map + (map (lambda (d)
                        (dof-analyze-for-canonical-run
                         (flatten-option-noise
                          (basic-statistics d))))
                      x)))

  (load-dof-results)
  (list (process (list 1dof-upper+lower-1 1dof-upper+lower-5
                       1dof-upper-1       1dof-upper-5
                       1dof-var-1         1dof-var-5))
        (process (list 2dof-upper+lower-1 2dof-upper+lower-5
                       2dof-upper-1       2dof-upper-5
                       2dof-var-1         2dof-var-5))
        (process (list 3dof-upper+lower-1 3dof-upper+lower-5
                       3dof-upper-1       3dof-upper-5
                       3dof-var-1         3dof-var-5))
        (process (list 4dof-upper+lower-1 4dof-upper+lower-5
                       4dof-upper-1       4dof-upper-5
                       4dof-var-1         4dof-var-5))))

; A different approach: just compute the average execution time for each
; setting, for all successful runs.  Lower is better.
;
; This gives (in seconds):
;  ((416.253 415.544 446.969 446.791)
;   (378.381 373.139 387.147 382.724)
;   (370.727 368.937 372.768 371.296)   <-- observe 3dof is low everywhere!
;   (373.651 373.952 372.871 372.577))
; which is the set of settings
;  1dof: 01
;  2dof: 01
;  3dof: 01
;  4dof: 11

(define (dof-analyze-for-canonical-run data)

  (define counters (make-vector 4 0))
  (define sums (make-vector 4 0.0))

  (for-each (lambda (x)
              (if (all-iterations-succeeded? x)
                  (let ((n (+ (* 2 (cdr (assq '-dof-fullgc-frequency x)))
                              (if (cdr (assq '-dof-no-shadow-remsets x))
                                  0
                                  1))))
                    (vector-set! counters n 
                                 (+ (vector-ref counters n) 1))
                    (vector-set! sums n
                                 (+ (vector-ref sums n) 
                                    (cdr (assq 'run-cpu-best x)))))))
            data)
  (map / (vector->list sums) (vector->list counters)))


; Clean up numbers from the second analysis procedure!

(define (dof-analysis-for-canonical-run:average-advantage)
  (map-leaves
   (lambda (x)
     (/ (round x) 1000.0))
   (dof-analysis-for-canonical-run)))

;;;

(define (create-dof-benchmark-2d-plot fn independent dependent data)
  (new-create-benchmark-2d-plot
   fn 
   (lambda (results)
     (extract-data results independent dependent))
   data))

(define (create-ndof-load-vs-mark/cons-plot prefix data)
  (load-dof-results)
  (create-dof-benchmark-2d-plot prefix
                                dof-effective-inverse-load
                                dof-mark-cons-ratio
                                (let ((x data))
                                  (list (list-ref x 0)
                                        (list-ref x 1)
                                        (list-ref x 4)
                                        (list-ref x 5)))))

(define (dof-mark-volume get bm)
  (get 'run-bytes-marked-best))

(define (dof-mark-cons-ratio get bm)
  (/ (dof-mark-volume get bm) (canonical-allocation bm)))

(define (dof-effective-inverse-load get bm)
  (/ (get 'bytes-max-heap) (profiled-peak-usage bm)))

(define (dof-mark-cons-plots)
  (for-each (lambda (f prefix)
              (create-ndof-load-vs-mark/cons-plot prefix (f)))
            (list 1dof-canonical-data
                  2dof-canonical-data
                  3dof-canonical-data
                  4dof-canonical-data)
            '("plots/dof-summary-plots/1D-"
              "plots/dof-summary-plots/2D-"
              "plots/dof-summary-plots/3D-"
              "plots/dof-summary-plots/4D-")))


; DOF traces we have on 2000-06-13
;
; Note, the data files are old (2000-02-10), and are not entirely
; compatible with current results (programs are in the heap, older
; collector version, etc).  The version of gcbench may even be the old
; one!

(define (dof-remset-traces1)
  (process-dof-remembered-set-trace 
   "plots/remset-traces/dof/earley12x5-remset-trace" 
   "plots/remset-traces/dof/5earley12")
  (process-dof-remembered-set-trace 
   "plots/remset-traces/dof/gcbench18x5-remset-trace"
   "plots/remset-traces/dof/5gcbench18")
  (process-dof-remembered-set-trace 
   "plots/remset-traces/dof/nboyer3x5-remset-trace" 
   "plots/remset-traces/dof/5nboyer3")
  (process-dof-remembered-set-trace 
   "plots/remset-traces/dof/sboyer4x5-remset-trace" 
   "plots/remset-traces/dof/5sboyer4")
  (process-dof-remembered-set-trace 
   "plots/remset-traces/dof/twobitx5-remset-trace" 
   "plots/remset-traces/dof/5twobitshort"))

; Remembered set traces obtained later, new format.

(define (dof-remset-traces2)
  (load-dof-rtrace-results)
  (process-dof-remset-traces 3.0 "plots/remset-traces/dof/"
                             (lambda () 
                               (append rtrace-4dof-var-1 rtrace-4dof-var-5))))

(define (dof-remset-traces3)
  (load-dof-rtrace-lastminute-results)
  (process-dof-remset-traces 3.0 "plots/remset-traces/dof/"
                             (lambda ()
                               rtrace-4dof-lastminute-var-1)))

(define (process-dof-remset-traces load prefix get-results)

  (define (select-settings raw-data)
    (dof-compute-canonical-data raw-data))
    
  (define (rsize xs)
    (sum (lambda (x) 
           (if (memq (car x) '(sha gen out))
               (sum (cdr x))
               0))
         xs))

  (define (doit trace dout gcout fullout)
    (process-rtrace 
     (make-generator (lambda (return)
                       (return '(start))
                       (do ((x trace (cdr x)))
                           ((null? x))
                         (case (caar x)
                           ((full) 
                            (return (list 'full (rsize (cddr (car x))))))
                           ((promote) 
                            (return (list 'promote (rsize (cdddr (car x))))))
                           ((collect) 
                            (return (list 'collect (rsize (cddddr (car x))))))
                           ((reset) #t)
                           (else
                            (error "Unrecognized trace record: " 
                                   (car x)))))
                       (return '(stop))
                       (return '(end))
                       (error "Read past end of trace.")))
     dout
     gcout
     fullout))

  (for-each (lambda (x)
              (display (benchmark-designator x))
              (display (cdr (assq 'system-info x)))
              (newline)
              (call-with-output-file 
                  (string-append
                   prefix
                   (sanitize-string
                    (format #f "~a~a-rtrace.data" 
                            (car (benchmark-designator x))
                            (cadr (benchmark-designator x)))))
                (lambda (dout)
                  (call-with-output-file 
                      (string-append
                       prefix
                       (sanitize-string
                        (format #f "~a~a-rtrace-gc.data"
                                (car (benchmark-designator x))
                                (cadr (benchmark-designator x)))))
                    (lambda (gcout)
                      (call-with-output-file
                          (string-append
                           prefix
                           (sanitize-string
                            (format #f "~a~a-rtrace-full.data"
                                    (car (benchmark-designator x))
                                    (cadr (benchmark-designator x)))))
                        (lambda (fullout)
                          (doit (cdr (assq 'run-remset-trace-best x)) 
                                dout 
                                gcout
                                fullout))))))))
            (select-load-factor 
             load 
             (select-settings (get-results)))))

; eof
