; Reorder runs of GCOLD in the tables of appendix A.
; 2000-12-03 / lth

(require 'string)
(require 'unix)

(define (hack-appendix-a)
  (for-each (lambda (f)
              (display f)
              (newline)
              (let ((newfn 
                     (string-append (substring f 0 (- (string-length f) 3))
                                    "safe")))
                (if (not (file-exists? newfn))
                    (rename-file f newfn))
                (hack-file newfn f)))
            (glob "build/tables/*.tex")))

(define (hack-file input output)
  (call-with-output-file output
    (lambda (out)
      (call-with-input-file input
        (lambda (in)

          (define (get)
            (read-line in))

          (define (put l)
            (display l out)
            (newline out))

          (define (state0 l)
            (cond ((eof-object? l))
                  ((substring-match l "gcold:10,1000")
                   (state1 (get) (list l)))
                  (else
                   (put l)
                   (state0 (get)))))

          (define (state1 l ls)
            (cond ((substring-match l "gcold:1,0")
                   (state2 (get) (list l) (reverse ls)))
                  (else
                   (state1 (get) (cons l ls)))))

          (define (state2 l ls last)
            (cond ((substring-match l "nboyer:3")
                   (for-each put (reverse ls))
                   (for-each put last)
                   (put l)
                   (state3 (get)))
                  (else
                   (state2 (get) (cons l ls) last))))

          (define (state3 l)
            (cond ((eof-object? l))
                  (else
                   (put l)
                   (state3 (get)))))

          (state0 (get)))))))