; 2000-06-20 / lth

(require 'comment)                      ; Generally useful

(load "scheme/crunch.sch")              ; Raw data w/crap -> raw data w/o crap

(load "scheme/common.sch")              ; General subroutines
(load "scheme/common-reports.sch")      ; Sundry processing/reporting code
(load "scheme/basic-statistics.sch")    ; Raw data w/o crap -> useful data
(load "scheme/basic-statistics-cache.sch") ; Speed that up some...
(load "scheme/process2.sch")            ; Misc processing code
(load "scheme/standard-report.sch")     ; Standard table code
(load "scheme/canonical.sch")           ; Canonical benchmark data
(load "scheme/comparative.sch")         ; Comparing runs
(load "scheme/latex.sch")               ; LaTeX plotting code
(load "scheme/html.sch")                ; HTML table generation
(load "scheme/remset-trace.sch")        ; Remset trace processing
(load "scheme/sc+gen.sch")              ; More reports

(load "scheme/stopcopy.sch")            ; SC crunching, reports, and plots
(load "scheme/generational.sch")        ; GEN crunching, reports, and plots
(load "scheme/dof.sch")                 ; DOF crunching, reports, and plots 
(load "scheme/rof.sch")                 ; ROF crunching, reports, and plots
(load "scheme/comparative-reports.sch") ; Comparative reports and plots


; FIXME: should also run GNUplot on the generated data.

(define (regenerate-everything)

  ; Regenerate all SC results
  (canned-sc-tables-and-plots)          ; in stopcopy.sch

  ; Regenerate all GEN results
  (canned-gen-tables-and-plots)         ; in generational.sch

  ; Regenerate all DOF results
  (canned-dof-tables-and-plots)         ; in dof.sch

  ; Regenerate all ROF results
  (canned-rof-tables-and-plots)         ; in rof.sch

  ; Regenerate comparative plots
  (canned-sc-vs-gen-plots)              ; in comparative-reports.sch
  (canned-2gen-vs-3gen-plots)           ; ditto
  (canned-gen-vs-dof-plots)             ; ditto
  (canned-gen-vs-rof-plots)             ; ditto

  'everything!)

; eof
