; Simple script to compile all benchmarks with all settings.
; $Id: compile-all.sch,v 1.4 1999/09/13 17:26:07 lth Exp $
;
; Just evaluate (compile-all).

(define *programs*
  '((dummy . "benchmarks/dummy.sch")
;    (dynamic . "benchmarks/dynamic.sch")
    (earley . "benchmarks/earley.sch")
    (gcbench . "benchmarks/gcbench.sch")
    (gcold . "benchmarks/gcold.sch")
;    (graphs . "benchmarks/graphs.sch")
    (lattice . "benchmarks/lattice.sch")
    (nboyer . "benchmarks/nboyer.sch")
;    (nucleic . "benchmarks/nucleic.sch")
    (perm . "benchmarks/perm9.sch")
;    (perm8 . "benchmarks/perm8.sch")
;    (perm9 . "benchmarks/perm9.sch")
    (pnboyer . "benchmarks/pnboyer.sch")
    (psboyer . "benchmarks/psboyer.sch")
    (sboyer . "benchmarks/sboyer.sch")
;    (softscheme . "benchmarks/softscheme.sch")
;    (textsearch . "benchmarks/textsearch.sch")
    (twobit . "benchmarks/twobit.sch")
    (vnboyer . "benchmarks/vnboyer.sch")
    ))

(define *compilers*
  `(;(bdw . ,compile-file-bdw)
    ;(common . ,compile-file-common)
    (gen . ,compile-file-gen)
    (sc . ,compile-file-sc)))

(define (compile-benchmark tag)
  (let* ((probe (assq tag *programs*))
         (file (cdr probe)))
    (display "Compiling ")
    (display file)
    (newline)
    (for-each (lambda (compile-file) ((cdr compile-file) file))
              *compilers*)))
  
(define (compile-system tag)
  (let* ((probe (assq tag *compilers*))
         (compiler (cdr probe)))
    (display "Compiling...")
    (newline)
    (for-each (lambda (program) 
                (display "  ")
                (display (car program))
                (newline)
                (compiler (cdr program)))
              *programs*)))
  
(define (compile-all)
  (for-each (lambda (program) (compile-benchmark (car program)))
            *programs*)
  (display "Compiling scheme/prefix.sch") 
  (newline)
  (compile-file-common "scheme/prefix.sch")
  (rename-file "scheme/prefix-common.fasl" "scheme/prefix.fasl")
  #t)

; eof
